// $Id$     
package com.adventnet.servicedesk.notification.util;

import java.net.UnknownHostException;
import java.io.*;
import java.net.URI;
import java.util.*;
import java.util.Collections;
import java.util.SortedMap;
import java.util.regex.*;

import javax.mail.Session;
import javax.mail.Message;
import javax.mail.Transport;
import javax.mail.Multipart;
import javax.mail.MessagingException;

import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeUtility;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMultipart;
import javax.mail.internet.MimeBodyPart;

import com.adventnet.servicedesk.utils.DataAccessUtil;

import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.servlet.http.HttpServletRequest;
import javax.transaction.SystemException;

import java.net.URLDecoder;
import java.rmi.RemoteException;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.io.File;
import java.util.List;
import java.util.Locale;
import java.util.Date;
import java.util.TimeZone;
import java.util.Vector;
import java.util.Iterator;
import java.util.Hashtable;
import java.util.Properties;
import java.util.Enumeration;
import java.util.Map.Entry;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.io.UnsupportedEncodingException;

import com.manageengine.servicedesk.setup.util.HttpClientUtil;
import com.sun.mail.smtp.SMTPAddressFailedException;
//EWS jars
import com.sun.mail.util.MailConnectException;
import microsoft.exchange.webservices.data.core.ExchangeService;
import microsoft.exchange.webservices.data.core.WebProxy;
import microsoft.exchange.webservices.data.core.enumeration.misc.TraceFlags;
import microsoft.exchange.webservices.data.core.enumeration.property.BodyType;
import microsoft.exchange.webservices.data.core.service.item.EmailMessage;
import microsoft.exchange.webservices.data.credential.ExchangeCredentials;
import microsoft.exchange.webservices.data.credential.WebCredentials;
import microsoft.exchange.webservices.data.credential.WebProxyCredentials;
import microsoft.exchange.webservices.data.misc.ITraceListener;
import microsoft.exchange.webservices.data.property.complex.EmailAddress;
import microsoft.exchange.webservices.data.property.complex.FileAttachment;
import microsoft.exchange.webservices.data.property.complex.MessageBody;
//EWS jars

import org.json.JSONObject;
import org.json.JSONArray;
import org.json.JSONException;

import com.adventnet.servicedesk.common.StringUtil;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.InputStream;

import com.adventnet.ds.query.Join;
import com.adventnet.ds.query.Range;
import com.adventnet.ds.query.Table;
import com.adventnet.ds.query.Column;
import com.adventnet.ds.query.Criteria;
import com.adventnet.ds.query.SortColumn;
import com.adventnet.ds.query.QueryConstants;
import com.adventnet.ds.query.SelectQueryImpl;
import com.adventnet.ds.query.SelectQuery;
import com.adventnet.ds.query.UpdateQuery;
import com.adventnet.persistence.DataAccess;
import com.adventnet.ds.query.UpdateQueryImpl;
import com.adventnet.persistence.Row;
import com.adventnet.persistence.DataObject;
import com.adventnet.persistence.DataAccessException;

import com.adventnet.servicedesk.common.StringUtil;
import com.adventnet.servicedesk.server.utils.SDClientUtil;
import com.adventnet.servicedesk.utils.DBUtilities;
import com.adventnet.servicedesk.kbase.util.AttachmentUtil;
import com.adventnet.servicedesk.util.CacheUtil;
import com.adventnet.servicedesk.util.NotificationUtilInterface;
import com.adventnet.servicedesk.utils.ResourcesUtil;
import com.adventnet.servicedesk.utils.ServiceDeskUtil;


import com.adventnet.servicedesk.ServiceDeskErrorCode;
import com.adventnet.servicedesk.ServiceDeskException;
import com.adventnet.asset.*;
//For SMTP Auth
import com.adventnet.servicedesk.security.Encoder;
import com.adventnet.servicedesk.common.MailUtilities;
import com.adventnet.servicedesk.common.SMTPAuthenticator;
import com.adventnet.authentication.*;
import com.adventnet.servicedesk.util.AeSdpBridgeInterface;
import com.adventnet.servicedesk.utils.ErrorLogUtil;
import com.adventnet.servicedesk.utils.MSPFactory;

import com.adventnet.servicedesk.utils.GlobalConfigUtil;
import com.adventnet.client.util.web.WebClientUtil;
import com.manageengine.servicedesk.security.XSSEncoder;

import com.manageengine.servicedesk.sdpapi.util.SDPAPIJSONUtil;
import com.manageengine.servicedesk.setup.util.DelimiterUtil;
import com.manageengine.servicedesk.utils.HtmlParser;
import com.sun.mail.imap.protocol.Status;
import com.sun.mail.util.MailConnectException;

public class NotificationFactory
{
    // the below variable is used to parse the received mail subject for getting the workorderid
    // in case if the 'in-reply-to', 'references' headers are not present

    public static String TITLEDELIMITER = "##";//No I18N
    private static NotificationFactory notificationFactory = null;
    private Logger logger = Logger.getLogger(NotificationFactory.class.getName());
    private StringUtil strUtil = null;
    private DBUtilities dbUtil = null;
    private HashMap inlineAttachments = null;
    public static ServiceDeskUtil serviceDeskUtil = null;
    private HashMap<String, DataObject> notificationDetails = null;
    private HashMap<String, Boolean> notificationStatus = null;
    //cwf
    private HashMap<Long, DataObject> notificationIDVsDetails = null;

        /*private static final String DEFAULTEMAILDELIMITER = ",";
        public static final String NONBLOCKED_EMAILS = "NONBLOCKED_EMAILS"; //No I18N
        public static final String BLOCKED_EMAILS = "BLOCKED_EMAILS"; //No I18N*/
    /**
     * Private constructor for the Singleton Class
     * @throws Exception
     */
    private NotificationFactory() throws Exception
    {
        logger.log(Level.INFO, " NotificationFactory private constructor ");
        strUtil = new StringUtil();
        dbUtil = DBUtilities.getInstance();
        serviceDeskUtil=ServiceDeskUtil.getInstance();
        //SD-74325
        try
        {
            logger.log(Level.INFO, "Going to set system property - mail.mime.encodeparameters=false");
            System.setProperty("mail.mime.encodeparameters", "false");
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }

    /**
     * Method to invoke the private constructor so that only one instance of this object will exist.
     * @return
     * @throws Exception
     */
    public static synchronized NotificationFactory getInstance() throws Exception
    {
        if (notificationFactory == null)
        {
            notificationFactory = new NotificationFactory();
        }
        return notificationFactory;
    }

    /**
     * Method used to send the notification for all module
     * @param templateName - Notification template name
     * @param dObj - Containing notification data
     * @param escalateToID - Notify to userID
     */
    public Vector sendNotification(String templateName, DataObject dObj, Long escalateToID) throws Exception
    {
        Vector notificationIDs = new Vector();
        String[] mailId = null;
        String[] notificationContent = getNotificationContent(templateName, dObj);
        String subject = notificationContent[0];
        String description = notificationContent[1];

        if(notificationContent != null)
        {
            Hashtable notifyUsers = null;

            if ("Contract_Notification".equals(templateName))
            {
                notifyUsers = getUsersToNofity(escalateToID, "E-Mail");//No I18N
                Row contractRow = dObj.getFirstRow(MAINTENANCECONTRACT.TABLE);
                Long contractID = (Long) contractRow.get(MAINTENANCECONTRACT.CONTRACTID);
                SelectQuery sq = new SelectQueryImpl(new Table(CONTRACTNOTIFICATIONMAILIDS.TABLE));
                sq.addSelectColumn(new Column(CONTRACTNOTIFICATIONMAILIDS.TABLE, "*"));
                Criteria cr = new Criteria(Column.getColumn(CONTRACTNOTIFICATIONMAILIDS.TABLE, CONTRACTNOTIFICATIONMAILIDS.CONTRACTID), contractID, QueryConstants.EQUAL);//No I18N
                sq.setCriteria(cr);
                DataObject notifyMailDO = ResourcesUtil.getInstance().get(sq);

                if (notifyMailDO.containsTable(CONTRACTNOTIFICATIONMAILIDS.TABLE))
                {
                    Row NotifyMailRow = notifyMailDO.getFirstRow(CONTRACTNOTIFICATIONMAILIDS.TABLE);
                    String mailIds = (String) NotifyMailRow.get(CONTRACTNOTIFICATIONMAILIDS.MAILID);
                    mailId = mailIds.split(",");
                }
            }
            else if ("Purchase_Notification".equals(templateName))
            {
                notifyUsers = new Hashtable(1);
                String userAddress = getNotifyToAddress(escalateToID, "E-Mail");//No I18N
                if (userAddress != null)
                {
                    notifyUsers.put(escalateToID, userAddress);
                }
            }
            else if ("notifyProhibitedSWToUsers".equals(templateName))
            {
                notifyUsers = new Hashtable(1);
                String userAddress = getNotifyToAddress(escalateToID, "E-Mail");//No I18N
                if (userAddress != null)
                {
                    notifyUsers.put(escalateToID, userAddress);
                }
            }
            else if ("PROverdueNotification".equals(templateName))
            {
                notifyUsers = new Hashtable(1);
                String userAddress = ServiceDeskUtil.getInstance().getUserEMailID(escalateToID);
                if (userAddress != null)
                {
                    notifyUsers.put(escalateToID, userAddress);

                    String url = SDClientUtil.getRequestScheme() + "://" + ServiceDeskUtil.getInstance().getSDWebUrl() + "/PurchaseRequest.do?task=viewPR&requestId=" + dObj.getFirstRow(PURCHASEREQUEST.TABLE).get(PURCHASEREQUEST.REQUESTID) + "&sectionLoad=false";//No I18N

                    description = description.replaceAll(("\\$"+"Link"),url);//NO I18N
                }
            }
            else
            {
                notifyUsers = getUsersToNofity(escalateToID, "E-Mail");//No I18N
            }

            if (notifyUsers.size() > 0)
            {
                Enumeration enum0 = notifyUsers.keys();
                String messageID = null;
                int flag = 0;
                subject = subject.replaceAll("<br>", ", ");//No I18N
                for (int i = 0; i < notifyUsers.size(); i++)
                {
                    Long userId = (Long) enum0.nextElement();
                    String emailId = (String) notifyUsers.get(userId);
                    try
                    {
                        messageID = sendMailNotificationAsHtml(emailId, subject, description, null);
                    }
                    catch (Exception e)
                    {
                        logger.log(Level.INFO, "Invalid E-Mail Id : " + emailId);
                        e.printStackTrace();
                    }
                            /*String toAddress = strUtil.makeString(ServiceDeskUtil.getValuesVector(notifyUsers));
                            subject = subject.replaceAll("<br>", ", ");//No I18N
                            String messageID = sendMailNotificationAsHtml(toAddress, subject, description,null);*/
                    if (messageID != null && flag == 0)
                    {
                        Long notificationID = populateNotificationTable(userId, null, subject, description, templateName, messageID, emailId);
                        if (notificationID != null)
                        {
                            notificationIDs.add(notificationID);
                        }
                        flag = 1;
                    }
                }
            }
            if (mailId != null)
            {
                subject = subject.replaceAll("<br>", ", ");//No I18N
                for (int i = 0; i < mailId.length; i++)
                {
                    try
                    {
                        String messageID = sendMailNotificationAsHtml(mailId[i].trim(), subject, description, null);
                    }
                    catch (Exception e)
                    {
                        logger.log(Level.INFO, "Invalid E-Mail Id : " + mailId[i].trim());
                        e.printStackTrace();
                    }
                }
            }
        }
        return notificationIDs;
    }
    public Vector sendNotification(String moduleName,Object id,Long escalateToID) throws ServiceDeskException {
        return sendNotification(moduleName,id,escalateToID,null);
    }
    /**
     *
     * @param moduleName
     * @param id
     * @param escalateToID
     * @return
     * @throws ServiceDeskException
     */
    public Vector sendNotification(String moduleName,Object id,Long escalateToID,Long level) throws ServiceDeskException
    {
        logger.log(Level.FINE, " sendNotification moduleName :{0} id :{1} escalateToID {2}", new Object[]{moduleName, id, escalateToID});
        Vector notificationIDs = new Vector();
        if (checkForEscalateToID(escalateToID) || moduleName.equals("PurchaseOrder") || moduleName.equals("Request") || moduleName.equals("Request_FR") || moduleName.equals("Contract")) // No I18N
        {
            try
            {
                DataObject noDO = ServiceDeskUtil.getInstance().getNotifyTypeDefDO();
                logger.log(Level.FINE, "NotificationDO: {0}", noDO);
                Criteria cr = new Criteria(Column.getColumn(NOTIFYTYPEDEF.TABLE, NOTIFYTYPEDEF.NOTIFYTYPENAME), "E-Mail", QueryConstants.EQUAL);
                String noType = (String) noDO.getValue(NOTIFYTYPEDEF.TABLE, NOTIFYTYPEDEF.NOTIFYTYPENAME, cr);

                Hashtable notifyUsers = new Hashtable();

                //To get the content/description constitued with the values for the configured fields
                String desc = "";
                String content = null;

                // here we can get the SLA violation notification for the request
                if ((moduleName.equals("Request_FR") || moduleName.equals("Request")) && noType.equals("E-Mail")) // No I18N
                {
                    // get sla violation values..
                    SelectQuery sql = getSelectQuery("Request", id);//No I18N
                    DataObject dobj = DataAccessUtil.getInstance().get(sql);

                    if(dobj.containsTable("WorkOrderToDescription"))//No I18N
                    {
                        Iterator tmpItr = dobj.getRows("WorkOrderToDescription");//No I18N
                        Row tmpRow = (Row)tmpItr.next();
                        Long attachID = (Long)tmpRow.get("ATTACHMENTID"); //No I18N
                        if(attachID!=null)
                        {
                            String content1 = AttachmentUtil.getInstance().readDescriptionAsAttachment(attachID);
                            if(content1.length()>0)
                            {
                                tmpRow.set("FULLDESCRIPTION",content1);//No I18N
                                dobj.updateRow(tmpRow);
                            }
                        }
                    }
                    if (!dobj.isEmpty())
                    {
                        if (moduleName.equals("Request"))
                        { // No I18N
                            // get the string value in NotificationContent for the value TechSLAEscalation_E-Mail
                            desc = getSubjectConfiguration("TechSLAEscalation_E-Mail");//No I18N
                            desc = NotificationStringParser.getInstance().getNotificationString(dobj, desc);
                            content = getContentConfiguration("TechSLAEscalation_E-Mail");//No I18N
                            content = NotificationStringParser.getInstance().getNotificationString(dobj, content);
                        }
                        else
                        {
                            // get the string value in NotificationContent for the value TechSLAEscalation_E-Mail
                            desc = getSubjectConfiguration("TechFRSLAEscalation_E-Mail"); // No I18N
                            desc = NotificationStringParser.getInstance().getNotificationString(dobj, desc); // No I18N
                            content = getContentConfiguration("TechFRSLAEscalation_E-Mail"); // No I18N
                            content = NotificationStringParser.getInstance().getNotificationString(dobj, content);
                        }
                    }
                    else
                    {
                        desc = "Request over due notification";//No I18N
                        content = "It seems that the request with request id " + id + " got deleted when it is about to get overdue.";//No I18N
                    }
                }
                else
                {
                    // Getting the content constitued with the values for the configured fields
                    if (moduleName.equals("Contract") || moduleName.equals("PurchaseOrder"))
                    {
                        SelectQueryImpl sql = getSelectQuery(moduleName, id);
                        DataObject dobj = DataAccessUtil.getInstance().get(sql);
                        if (moduleName.equals("Contract"))
                        {
                            desc = NotificationStringParser.getInstance().getSubjectConfiguration("Contract_Notification");//No I18N
                            desc = NotificationStringParser.getInstance().getPO_ContractNotificationString(dobj, desc, "Contract");//No I18N
                            content = NotificationStringParser.getInstance().getContentConfiguration("Contract_Notification");//No I18N
                            content = NotificationStringParser.getInstance().getPO_ContractNotificationString(dobj, content, "Contract");//No I18N
                        }
                        if (moduleName.equals("PurchaseOrder"))
                        {
                            desc = NotificationStringParser.getInstance().getSubjectConfiguration("Purchase_Notification");//No I18N
                            desc = NotificationStringParser.getInstance().getPO_ContractNotificationString(dobj, desc, "PurchaseOrder");//No I18N
                            content = NotificationStringParser.getInstance().getContentConfiguration("Purchase_Notification");//No I18N
                            content = NotificationStringParser.getInstance().getPO_ContractNotificationString(dobj, content, "PurchaseOrder");//No I18N
                        }
                    }
                }

                logger.log(Level.FINE, " -------------------------------------------------------------- ");
                logger.log(Level.FINE, " content {0}", content);
                logger.log(Level.FINE, " noType {0}", noType);
                logger.log(Level.FINE, " -------------------------------------------------------------- ");

                // SD-43002: Hardcoding specifically for E-Mail as no SMS notification is meant to be made.
                if(noType.equals("E-Mail"))
                {
                    if (moduleName.equals("Request") || moduleName.equals("Request_FR")) // No I18N
                    {
                        NotificationUtilInterface nui = ((NotificationUtilInterface) Class.forName("com.adventnet.servicedesk.helpdesk.util.HdNotificationUtil").newInstance());//No I18N
                        notifyUsers = nui.getUsersToNofity1(escalateToID, id, noType, moduleName);
                    }
                    else
                    {
                        notifyUsers = getUsersToNofity(escalateToID, noType);
                        String userAddress = getNotifyToAddress(escalateToID, noType);
                        //notifyUsers.put(escalateToID,userAddress);
                        if (userAddress != null)
                        {
                            notifyUsers.put(escalateToID, userAddress);
                        }
                    }
                }
                else
                {
                    logger.log(Level.FINE, " Unknow notification type " + noType);
                }

                if (notifyUsers.size() > 0 && content != null)
                {
                    String toAddress = strUtil.makeString(ServiceDeskUtil.getValuesVector(notifyUsers));
                    logger.log(Level.FINE, " toAddress " + toAddress);
                    String messageID = null;
                    if (com.adventnet.servicedesk.utils.ServiceDeskUtil.getInstance().isHtmlEnabledForNotification())
                    {
                        messageID = sendMailNotificationAsHtml(toAddress, desc, content, null);
                    }
                    else
                    {
                        messageID = sendMailNotification(toAddress, desc, content);
                    }

                    if (messageID != null)
                    {
                        Enumeration enum1 = notifyUsers.keys();
                        logger.log(Level.FINE, " notifyUsers " + notifyUsers);
                        Long toID = null;
                        for (int i = 0; i < notifyUsers.size(); i++)
                        {
                            toID = (Long) enum1.nextElement();
                        }
                        if (toID != null)
                        {
                            Long notificationID = populateNotificationTable(toID, null, desc, content, "REQESCALATION", messageID, toAddress,null, null, null,"Request");//No I18N
                            if (notificationID != null)
                            {
                                notificationIDs.add(notificationID);
                            }
                        }
                    }
                }
            }
            catch (ServiceDeskException sde)
            {
                throw sde;
            }
            catch (DataAccessException dae)
            {
                ServiceDeskException sde = new ServiceDeskException("Problem occured while fetching content for notification.", dae);//No I18N
                sde.setErrorCode(ServiceDeskErrorCode.ER_FETCHING_NOTIFY_CONTENT);
                throw sde;
            }
            catch (Exception e)
            {
                ServiceDeskException sde = new ServiceDeskException("Problem occured while fetching content for notification.", e);//No I18N
                sde.setErrorCode(ServiceDeskErrorCode.ER_FETCHING_NOTIFY_CONTENT);
                throw sde;
            }
        }
        return notificationIDs;
    }

    /**
     * This getContent and getContentFromFields methods code can be removed after analysis it
     * @param module
     * @param mode
     * @param id
     * @return
     * @throws ServiceDeskException
     */
    public String getContent(String module, String mode, Object id) throws ServiceDeskException
    {
        String content = null;
        try
        {
            Long notifyTypeID = (Long) dbUtil.getResultObject(NOTIFYTYPEDEF.TABLE, new Criteria(Column.getColumn(NOTIFYTYPEDEF.TABLE, NOTIFYTYPEDEF.NOTIFYTYPENAME), mode, QueryConstants.EQUAL), NOTIFYTYPEDEF.NOTIFYTYPEID);
            Criteria c1 = new Criteria(Column.getColumn(NOTIFYDEFINITION.TABLE, NOTIFYDEFINITION.NOTIFYTYPEID), notifyTypeID, QueryConstants.EQUAL);
            Criteria c2 = new Criteria(Column.getColumn(NOTIFYDEFINITION.TABLE, NOTIFYDEFINITION.MODULE), module, QueryConstants.EQUAL);
            c1 = c1.and(c2);
            Long notifyID = (Long) dbUtil.getResultObject(NOTIFYDEFINITION.TABLE, c1, NOTIFYDEFINITION.NOTIFYID);
            logger.log(Level.FINE, " notifyID {0}", notifyID);
            content = getContentFromFields(module, notifyID, id);
        }
        catch (ServiceDeskException sde)
        {
            throw sde;
        }
        catch (Exception e)
        {
            ServiceDeskException sde = new ServiceDeskException("Problem occured while fetching content for notification.", e);//No I18N
            sde.setErrorCode(ServiceDeskErrorCode.ER_FETCHING_NOTIFY_CONTENT);
            throw sde;
        }
        return content;
    }

    /**
     *
     * @param module
     * @param mode
     * @param id
     * @return
     * @throws ServiceDeskException
     */
    public ArrayList getContractContent(String module, String mode, Object id) throws ServiceDeskException
    {
        String subject = "";
        String description = "";
        ArrayList data = new ArrayList(2);
        try
        {
            SelectQueryImpl sql = getSelectQuery(module,id);
            DataObject dobj = ResourcesUtil.getInstance().get(sql);
            subject = NotificationStringParser.getInstance().getSubjectConfiguration("Contract_Notification");//No I18N
            subject = NotificationStringParser.getInstance().getPO_ContractNotificationString(dobj, subject,"Contract");//No I18N
            description = NotificationStringParser.getInstance().getContentConfiguration("Contract_Notification");//No I18N
            description = NotificationStringParser.getInstance().getPO_ContractNotificationString(dobj, description,"Contract");//No I18N
        }
        catch(Exception e)
        {
            ServiceDeskException sde = new ServiceDeskException("Problem occured while fetching content for notification.",e);//No I18N
            sde.setErrorCode(ServiceDeskErrorCode.ER_FETCHING_NOTIFY_CONTENT);
            throw sde;
        }
        data.add(subject);
        data.add(description);
        return data;
    }

    /**
     * The contract and purchase related parts have been moved to notificationstringparser.
     * @param moduleName
     * @param notifyID
     * @param id
     * @return
     * @throws ServiceDeskException
     */
    private String getContentFromFields(String moduleName,Long notifyID,Object id) throws ServiceDeskException
    {
        logger.log(Level.FINE," getContentFromFields ");
        String content = "";

        if( notifyID == null )
        {
            return content;
        }
        try
        {
            Criteria criteria = new Criteria(new Column(NOTIFYCONTENTDEF.TABLE,NOTIFYCONTENTDEF.NOTIFYID),notifyID,QueryConstants.EQUAL);
            SelectQueryImpl sqi = new SelectQueryImpl(new Table(NOTIFYCONTENTDEF.TABLE));
            SortColumn sc = new SortColumn(new Column(NOTIFYCONTENTDEF.TABLE,NOTIFYCONTENTDEF.COLUMNORDER), true);
            sqi.addSortColumn(sc);

            Criteria show = new Criteria(new Column(NOTIFYCONTENTDEF.TABLE,NOTIFYCONTENTDEF.COLUMNORDER),new Long(0),QueryConstants.NOT_EQUAL);
            criteria = criteria.and(show);

            sqi.addSelectColumn(new Column(NOTIFYCONTENTDEF.TABLE,NOTIFYCONTENTDEF.FIELDID));
            sqi.addSelectColumn(new Column(NOTIFYCONTENTDEF.TABLE,NOTIFYCONTENTDEF.NOTIFYID));
            sqi.addSelectColumn(new Column(NOTIFYCONTENTDEF.TABLE,NOTIFYCONTENTDEF.TABLENAME));
            sqi.addSelectColumn(new Column(NOTIFYCONTENTDEF.TABLE,NOTIFYCONTENTDEF.COLUMNNAME));
            sqi.addSelectColumn(new Column(NOTIFYCONTENTDEF.TABLE,NOTIFYCONTENTDEF.COLUMNALIAS));
            sqi.addSelectColumn(new Column(NOTIFYCONTENTDEF.TABLE,NOTIFYCONTENTDEF.COLUMNORDER));
            sqi.setCriteria(criteria);
            DataObject notifyContentDefDO = ResourcesUtil.getInstance().get(sqi);
            Iterator it = notifyContentDefDO.getRows(NOTIFYCONTENTDEF.TABLE);

            logger.log(Level.FINE,"---------------------------------------------------------------");
            logger.log(Level.FINE, " sqi {0}", sqi);
            logger.log(Level.FINE, " criteria {0}", criteria);
            logger.log(Level.FINE, " notifyContentDefDO {0}", notifyContentDefDO);
            logger.log(Level.FINE, " it {0}", it);
            logger.log(Level.FINE,"---------------------------------------------------------------");

            SelectQueryImpl sq = getSelectQuery(moduleName,id);
            logger.log(Level.FINE, " moduleName {0}", moduleName);
            logger.log(Level.FINE, " SelectQueryImpl {0}", sq);
            DataObject dataObject = ResourcesUtil.getInstance().get(sq);
            logger.log(Level.FINE, " dataObject {0}", dataObject);

            while(it.hasNext())
            {
                Row row = (Row)it.next();
                String tableName = (String)row.get(NOTIFYCONTENTDEF.TABLENAME);
                String columnName = (String)row.get(NOTIFYCONTENTDEF.COLUMNNAME);
                String columnAlias = (String)row.get(NOTIFYCONTENTDEF.COLUMNALIAS);
                Object obj = null;
                if(dataObject.containsTable(tableName))
                {
                    Iterator obj1 = dataObject.get(tableName,columnName);
                    if(obj1!=null)
                    {
                        boolean isFirstTime = true;
                        while (obj1.hasNext())
                        {
                            obj = obj1.next();
                            if(obj!=null)
                            {
                                if(columnName.indexOf("DATE")>=0 || columnName.indexOf("TIME")>=0)
                                {
                                    if(columnName.indexOf("DATE") >= 0)
                                    {
                                        String temp = ServiceDeskUtil.getDateAsString(ServiceDeskUtil.getInstance().getUserId(),(Long)obj,"N/A");//No I18N
                                        obj = temp;
                                    }
                                    else
                                    {
                                        String temp = ServiceDeskUtil.getTimeAsString(ServiceDeskUtil.getInstance().getUserId(),(Long)obj,"N/A");//No I18N
                                        obj = temp;
                                    }
                                }

                                if(!((obj.toString()).equals("-")))
                                {
                                    if(isFirstTime)
                                    {
                                        content = content + "<br>" + XSSEncoder.getInstance().encodeHTML(columnAlias) + " : " + XSSEncoder.getInstance().encodeHTML(obj.toString());//No I18N
                                    }
                                    else
                                    {
                                        content = content + "," +  XSSEncoder.getInstance().encodeHTML(obj.toString());//No I18N
                                    }
                                }
                            }
                            isFirstTime = false;
                        }
                    }
                }
            }
        }
        catch(Exception e)
        {
            e.printStackTrace();
            ServiceDeskException sde = new ServiceDeskException("Problem occured while fetching content for notification.",e);//No I18N
            sde.setErrorCode(ServiceDeskErrorCode.ER_FETCHING_NOTIFY_CONTENT);
            throw sde;
        }
        logger.log(Level.FINE, " content {0}", content);
        return content;
    }


    /**
     *
     * @param escalateToID
     * @param type
     * @return
     * @throws ServiceDeskException
     */
    public Hashtable getUsersToNofity(Long escalateToID,String type) throws ServiceDeskException,Exception
    {

        logger.log(Level.FINE, " inside getUsersToNofity ");
        Hashtable hash = new Hashtable();
        try
        {
            Vector users = dbUtil.getResultVector(ESCALATETON.TABLE, new Criteria(Column.getColumn(ESCALATETON.TABLE, ESCALATETON.ESCALATETOID), escalateToID, QueryConstants.EQUAL), ESCALATETON.USERID);
            for (int i = 0; i < users.size(); i++)
            {
                Long uID = (Long) users.get(i);
                Row userRow = new Row(AAAUSER.TABLE);
                userRow.set(AAAUSER.USER_ID, uID);
                DataObject userDO = ServiceDeskUtil.getInstance().getUserFromLRUCache(uID);
                logger.log(Level.FINE, " userDO {0}", userDO);
                if (userDO.containsTable("AaaUserContactInfo"))
                {
                    Long contID = (Long) userDO.getFirstValue(AAAUSERCONTACTINFO.TABLE, AAAUSERCONTACTINFO.CONTACTINFO_ID);
                    if (contID != null)
                    {
                        if (type.equals("E-Mail"))
                        {
                            String temp = (String) userDO.getFirstValue(AAACONTACTINFO.TABLE, AAACONTACTINFO.EMAILID);
                            if (temp != null && !temp.equals(""))
                            {
                                hash.put(uID, temp);
                            }
                        }
                        else if (type.equals("SMS"))
                        {
                            String temp= (String) userDO.getFirstValue(SDUSER.TABLE, SDUSER.SMSMAILID);
                            if(ServiceDeskUtil.getInstance().isServiceDeskBuild()){
                                AeSdpBridgeInterface sdpBridge = ((AeSdpBridgeInterface) Class.forName("com.adventnet.servicedesk.utils.AeSdpBridgeImpl").newInstance()); //No I18N
                                if(sdpBridge.isSMSGatewayConfigured())
                                {
                                    temp=(String) userDO.getFirstValue(AAACONTACTINFO.TABLE, AAACONTACTINFO.MOBILE);
                                    temp=temp.replaceAll("[()+_-]","");
                                    temp=temp.replaceAll("\\s","");//No I18N
                                }
                            }
                            if (temp != null && !temp.equals(""))
                            {
                                hash.put(uID, temp);
                            }
                        }
                    }
                }
            }
        }
        catch (Exception e)
        {
            ServiceDeskException sde = new ServiceDeskException("Problem occured while fetching the to addresses, for which the notification is to be sent.", e);//No I18N
            sde.setErrorCode(ServiceDeskErrorCode.ER_GETTING_TO_ADDRESSES);
            throw sde;
        }
        logger.log(Level.FINE, " hash getUsersToNofity {0}", hash);
        return hash;
    }


    /**
     *
     * @param uID
     * @param type
     * @return
     * @throws ServiceDeskException
     */
    public Hashtable getUsersAddress(Long uID,String type) throws ServiceDeskException
    {
        logger.log(Level.FINE, " inside getUsersAddress ");
        Hashtable hash = new Hashtable();
        try
        {
            Row userRow = new Row(AAAUSER.TABLE);
            userRow.set(AAAUSER.USER_ID, uID);
            DataObject userDO = ResourcesUtil.getInstance().getForPersonality("SDUser", userRow);
            logger.log(Level.FINE, " userDO {0}", userDO);
            if (userDO.containsTable(AAAUSERCONTACTINFO.TABLE))
            {
                Long contID = (Long) userDO.getFirstValue(AAAUSERCONTACTINFO.TABLE, AAAUSERCONTACTINFO.CONTACTINFO_ID);
                if (contID != null)
                {
                    Row contRow = new Row(AAACONTACTINFO.TABLE);
                    contRow.set(AAACONTACTINFO.CONTACTINFO_ID, contID);
                    DataObject contactDO = DataAccessUtil.getInstance().get(AAACONTACTINFO.TABLE, contRow);
                    logger.log(Level.FINE, "The contact DO is {0}", contactDO);
                    if (type.equals("E-Mail"))
                    {
                        String temp = (String) contactDO.getFirstValue(AAACONTACTINFO.TABLE, AAACONTACTINFO.EMAILID);
                        if (temp != null && !temp.equals(""))
                        {
                            hash.put(uID, temp);
                        }
                    }
                    else if (type.equals("SMS"))
                    {
                        String temp = (String) userDO.getFirstValue(SDUSER.TABLE, SDUSER.SMSMAILID);
                        if (temp != null && !temp.equals(""))
                        {
                            hash.put(uID, temp);
                        }
                    }
                }
            }
        }
        catch (Exception e)
        {
            ServiceDeskException sde = new ServiceDeskException("Problem occured while fetching the to addresses, for which the notification is to be sent.", e);//No I18N
            sde.setErrorCode(ServiceDeskErrorCode.ER_GETTING_TO_ADDRESSES);
            throw sde;
        }
        logger.log(Level.FINE, " hash getUsersToNofity {0}", hash);
        return hash;
    }

    /**
     *
     * @param userID
     * @param type
     * @return
     * @throws ServiceDeskException
     */
    public String getNotifyToAddress(Long userID,String type) throws ServiceDeskException,Exception
    {
        String notifyAddress = null;
        logger.log(Level.FINE, " getUsersToNofity : userID ---> {0}", userID);
        logger.log(Level.FINE, " getUsersToNofity : type ---> {0}", type);
        try
        {
            DataObject userDO = ServiceDeskUtil.getInstance().getUserFromLRUCache(userID);
            if (userDO.containsTable(AAAUSERCONTACTINFO.TABLE))
            {
                Long contID = (Long) userDO.getFirstValue(AAAUSERCONTACTINFO.TABLE, AAAUSERCONTACTINFO.CONTACTINFO_ID);
                if (contID != null)
                {
                    if (type.equals("E-Mail"))
                    {
                        notifyAddress = (String) userDO.getFirstValue(AAACONTACTINFO.TABLE, AAACONTACTINFO.EMAILID);
                        logger.log(Level.FINE, " getUsersToNofity : notifyAddress ---> ", notifyAddress);
                    }
                    else if (type.equals("SMS"))
                    {
                        AeSdpBridgeInterface sdpBridge = ((AeSdpBridgeInterface) Class.forName("com.adventnet.servicedesk.utils.AeSdpBridgeImpl").newInstance()); //No I18N
                        if(sdpBridge.isSMSGatewayConfigured())
                        {
                            notifyAddress=(String) userDO.getFirstValue(AAACONTACTINFO.TABLE, AAACONTACTINFO.MOBILE);
                            notifyAddress=notifyAddress.replaceAll("[()+_-]","");
                            notifyAddress=notifyAddress.replaceAll("\\s","");//No I18N
                        }
                        else{
                            notifyAddress = (String) userDO.getFirstValue(SDUSER.TABLE, SDUSER.SMSMAILID);
                        }
                        logger.log(Level.FINE, " getUsersToNofity : notifyAddress ---> ", notifyAddress);
                    }
                }
            }
        }
        catch (Exception e)
        {
            ServiceDeskException sde = new ServiceDeskException("Problem occured while fetching the to address, for which the notification is to be sent.", e);//No I18N
            sde.setErrorCode(ServiceDeskErrorCode.ER_GETTING_TO_ADDRESSES);
            throw sde;
        }
        logger.log(Level.FINE, " notifyAddress: {0}", notifyAddress);
        return notifyAddress;
    }


    public String sendMailNotification(String toAddress, String title, String description) throws ServiceDeskException
    {
        return sendMailNotification(toAddress, title, description, null);
    }

    public String sendMailNotification(String toAddress, String title, String description, String ccAddress) throws ServiceDeskException
    {
        return sendMailNotification(toAddress, title, description, ccAddress, null);
    }

    public String sendMailNotification(String toAddress, String title, String description, String ccAddress, String contentType) throws ServiceDeskException
    {
        return sendMailNotification(toAddress, title, description, ccAddress, contentType, null);
    }

    /*The contentType String must be specified to set content type as either plain or html if null plain is set */
    public String sendMailNotification(String toAddress, String title, String description, String ccAddress, String contentType, String[] fileAttachments) throws ServiceDeskException
    {
        return sendMailNotification(toAddress, title, description, ccAddress, contentType, fileAttachments, null, null, null);
    }

    public String sendMailNotification(String toAddress, String title, String description, String ccAddress, String contentType, String[] fileAttachments, String inReplyTo) throws ServiceDeskException
    {
        return sendMailNotification(toAddress, title, description, ccAddress, contentType, fileAttachments, null, null, inReplyTo);
    }

    public String sendMailNotificationAsHtml(String toAddress, String title, String description, String ccAddress, Long userId) throws ServiceDeskException
    {
        // replace description for any \n with <br>
        //description = description.replaceAll("\n", "<br>");
        return sendMailNotification(toAddress, title, description, ccAddress, "text/html", null, userId);//No I18N
    }

    public String sendMailNotificationAsHtml(String toAddress, String title, String description, String ccAddress, Long userId, Long queueId) throws ServiceDeskException
    {
        return sendMailNotification(toAddress, title, description, ccAddress, "text/html", null, userId, queueId, null);//No I18N
    }
    public String sendMailNotificationAsHtml(String toAddress, String title, String description, String ccAddress, Long userId, Long queueId, HashMap inlineAtt) throws ServiceDeskException
    {
        this.inlineAttachments = inlineAtt;
        try{
            return sendMailNotification(toAddress, title, description, ccAddress, "text/html", null, userId, queueId, null, null);	//No I18N
        }
        catch(ServiceDeskException e){
            logger.log(Level.FINE, "Exception occured while sending requester acknowledgement mail with icons as inlineAttachments:: {0}", e.getMessage());
            throw e;
        }
    }
    public String sendMailNotificationAsHtml(String toAddress, String title, String description, Long userId) throws ServiceDeskException
    {
        // replace description for any \n with <br>
        //description = description.replaceAll("\n", "<br>");
        return sendMailNotification(toAddress, title, description, null, "text/html", null, userId);//No I18N
    }

    public String sendMailNotification(String toAddress, String title, String description, String ccAddress, String contentType, String[] fileAttachments, Long userId) throws ServiceDeskException
    {
        return sendMailNotification(toAddress, title, description, ccAddress, contentType, fileAttachments, userId, null, null);
    }

    public String sendMailNotification(String toAddress, String title, String description, String ccAddress, String contentType, String[] fileAttachments, Long queueId, String inReplyTo) throws ServiceDeskException
    {
        return sendMailNotification(toAddress, title, description, ccAddress, contentType, fileAttachments, null, queueId, inReplyTo);
    }

    public String sendMailNotification(String toAddress, String title, String description, String ccAddress, String contentType, String[] fileAttachments, Long userId, Long queueId, String inReplyTo) throws ServiceDeskException
    {
        // SD - 24351 - from email address registered with our ServiceDesk install is considered instead the technicians email address
        return sendMailNotification(toAddress, title, description, ccAddress, contentType, fileAttachments, userId, queueId, inReplyTo, null);
    }
    public String sendMailNotification(String toAddress, String title, String description, String ccAddress, String contentType, String[] fileAttachments, Long userId, Long queueId, String inReplyTo, String reportTitle) throws ServiceDeskException
    {
        //sd-58569: report name showing timestamp
        return sendMailNotification(null, toAddress, title, description, ccAddress, contentType, fileAttachments, userId, queueId, inReplyTo, reportTitle);
    }
    public String sendMailNotification(String sender, String toAddress, String title, String description, String ccAddress, String contentType, String[] fileAttachments, Long userId, Long queueId, String inReplyTo, String reportTitle) throws ServiceDeskException
    {
        return sendMailNotification( sender,toAddress,title,  description, ccAddress,contentType,fileAttachments,userId,queueId,inReplyTo,reportTitle,null,null,false);

    }
    /**
     * @param sender
     * @param toAddress
     * @param title
     * @param description
     * @param ccAddress
     * @param contentType
     * @param fileAttachments
     * @param userId
     * @param queueId
     * @param inReplyTo
     * @param reportTitle
     * @param module
     * @param moduleId
     * @param sendPartial-If true,mail will be sent even if one of the recepients' email id is invalid and syslog will be populated with his id
     * @return
     * @throws ServiceDeskException
     */
    public String sendMailNotification(String sender, String toAddress, String title, String description, String ccAddress, String contentType, String[] fileAttachments, Long userId, Long queueId, String inReplyTo, String reportTitle,String module,Long moduleId,boolean sendPartial) throws ServiceDeskException
    {
        logger.log(Level.FINE, "sender >>> "+sender);
        logger.log(Level.FINE, "toAddress >>> "+toAddress);
        logger.log(Level.FINE, "title >>> "+title);
        logger.log(Level.FINE, "description >>> "+description);
        logger.log(Level.FINE, "ccAddress >>> "+ccAddress);
        String fromAddress = sender;
        String fromName = null;
        String messageID = null;
        String mailServer = "javamail";//NO I18N
        Boolean isDebuggerEnabled = false;
        try {
            mailServer = MailUtilities.getInstance().getSelectedOutgoingServer();
            isDebuggerEnabled = (Boolean) MailUtilities.getInstance().getCommonMailProperties().get("maildebug");//NO I18N
        }
        catch(Exception e)
        {
            logger.log(Level.INFO,"Error while fetching current mailserver");
            ServiceDeskException sde = new ServiceDeskException("Exception while trying to fetch current mail server.", e);//No I18N
            sde.setErrorCode(ServiceDeskErrorCode.ER_FETCHING_DATA);
            throw sde;
        }
        ArrayList parts = new ArrayList();
        ArrayList ewsAttMap = new ArrayList();
        String senderAddress = null;
        String fromAddress1 = null;
        String fromName1 = null;
        title = title.replaceAll("\r\n", "");//No I18N
        title = title.replaceAll("\n", "");//No I18N
        if(module != null && moduleId != null)
        {
            try
            {
                title = getSubjectWithModuleDelim(title, module, moduleId);
            }
            catch (Exception e)
            {
                //Check module name
                logger.log(Level.WARNING, "exception when appending delimeter to subject");
                e.printStackTrace();
            }
        }
        //SD-62625 fix - SMS not sent via Business Rule due to empty content type
        if("".equals(contentType)){
            contentType = null;
        }
        if (toAddress != null && !toAddress.equals("")) {
            try {
                if (queueId != null) {
                    logger.log(Level.INFO, "F_ADD : queueId : {0}", queueId);
                    Vector vtr = ServiceDeskUtil.getInstance().getSenderDetails(queueId);
                    if (vtr != null) {
                        Hashtable ht = (Hashtable) vtr.elementAt(0);
                        fromName = (String) ht.get("SENDERNAME");
                        fromAddress = (String) ht.get("REPLYADDRESS");
                    }
                    logger.log(Level.INFO, "F_NAME : fromName : {0}", fromName);
                    logger.log(Level.INFO, "F_ADD : fromAddres : {0}", fromAddress);
                } else if (userId != null) {
                    DataObject aaaConInfoDo = ServiceDeskUtil.getInstance().getUserFromLRUCache(userId);
                    if (aaaConInfoDo.containsTable(AAACONTACTINFO.TABLE)) {
                        fromAddress = (String) aaaConInfoDo.getFirstValue(AAACONTACTINFO.TABLE, AAACONTACTINFO.EMAILID);
                    }
                }
                if(mailServer.equalsIgnoreCase("javamail"))
                {
                    DataObject aliasesDO = MailUtilities.getInstance().getOutgoingMailAliases();
                    fromAddress1 = (String) aliasesDO.getFirstValue(OUTGOINGMAILALIASES.TABLE, OUTGOINGMAILALIASES.FROMEMAILID);
                    fromName1 = (String) aliasesDO.getFirstValue(OUTGOINGMAILALIASES.TABLE, OUTGOINGMAILALIASES.SENDERNAME);
                }
                else
                {
                    DataObject aliasesDO = DataAccessUtil.getInstance().get(OUTGOINGEWSSERVER.TABLE, (Criteria) null);
                    fromAddress1 = (String) aliasesDO.getFirstValue(OUTGOINGEWSSERVER.TABLE, OUTGOINGEWSSERVER.FROMEMAILID);
                    fromName1 = (String) aliasesDO.getFirstValue(OUTGOINGEWSSERVER.TABLE, OUTGOINGEWSSERVER.SENDERNAME);
                }
                if (ServiceDeskUtil.getInstance().isMSPLicense()) {
                    if ("requester".equalsIgnoreCase(ServiceDeskUtil.getInstance().getUserType())) {
                        HashMap senderInfo = MSPFactory.getMSPDeskUtil().getMSPSenderInfo(ServiceDeskUtil.getInstance().getUserId());
                        if (senderInfo != null) {
                            fromAddress = (String) senderInfo.keySet().toArray()[0];
                            fromName = (String) senderInfo.get(fromAddress);
                            senderAddress = fromAddress1;
                        }
                    }
                    if (fromAddress == null || fromAddress.equals("")) {

                        HashMap senderInfo = MSPFactory.getMSPDeskUtil().getMSPSenderInfo(toAddress, ccAddress);
                        if (senderInfo == null) {
                            senderInfo = MSPFactory.getMSPDeskUtil().getMSPSenderInfo(userId);
                        }
                        if (senderInfo != null) {
                            fromAddress = (String) senderInfo.keySet().toArray()[0];
                            fromName = (String) senderInfo.get(fromAddress);
                            senderAddress = fromAddress1;
                        }
                    }
                }
                if (fromAddress == null || fromAddress.equals("")) {
                    fromAddress = fromAddress1;
                    fromName = fromName1;
                }
                logger.log(Level.INFO, " fromAddress ---------> " + fromAddress);
                logger.log(Level.INFO, " fromName ---------> " + fromName);
            } catch (Exception e) {
                ServiceDeskException sde = new ServiceDeskException("Problem occured while fetching the from address for the notification to be sent.", e);//No I18N
                sde.setErrorCode(ServiceDeskErrorCode.ER_FETCHING_DATA);//No I18N
                throw sde;
            }
            if (contentType == null || ("text/plain").equals(contentType)) {
                try {
                    description = ServiceDeskUtil.getInstance().getHTMLStrippedValue(description);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            } else {
                // Code for adding the inline images along with the mail.//No I18N
                try {
                    String content = description;

                    //SD-66673 we have removed our existing parser.used with jsoup thirdparty parser.
                    content = HtmlParser.getInstance().fixImageUrls(content);
                    ArrayList imageUrls = HtmlParser.getInstance().getInlineImageUrls(content);
                    if (mailServer.equalsIgnoreCase("javamail")) {
                        for (int i = 0; i < imageUrls.size(); i++) {
                            String fileName = ".." + File.separator + (String) imageUrls.get(i);//No I18N
                            File file = new File(fileName);
                            //If the attached linline image is missing then we could not send REPLY/FORWARD mail.
                            //Before to add the image in mime part, we are check whether the file exists.
                            logger.log(Level.FINE, "debug :: Going to add file name::{0}", file);
                            if (file.exists()) {
                                FileDataSource source = new FileDataSource(file);
                                DataHandler handler = new DataHandler(source);
                                MimeBodyPart imageMbp = new MimeBodyPart();
                                imageMbp.setDataHandler(handler);
                                //SD 59972, SD 60583 Outlook fix unique cid for images
                                long currentTime = System.currentTimeMillis();
                                //Setting the content-type for the signature images ( SD-71122 )
                                imageMbp.setHeader("Content-ID", "<Image" + currentTime + i + ">");//No i18N
                                imageMbp.setHeader("Content-Type", "image/"+fileName.substring(fileName.lastIndexOf('.')+1));
                                imageMbp.setFileName(fileName.substring(fileName.lastIndexOf(File.separator)+1));
                                imageMbp.setDisposition(MimeBodyPart.INLINE);
                                String partId = "cid:Image" + currentTime + i;//No i18N
                                parts.add(imageMbp);
                                content = content.replaceFirst((String) imageUrls.get(i), partId);
                            }//INLINE ISSUE
                            else {
                                logger.log(Level.INFO, "debug : The mentioned inline image does not exist in respective directory :: {0}", fileName);
                            }
                        }
                    } else {
                        for (int i = 0; i < imageUrls.size(); i++) {
                            String fileName = ".." + File.separator + (String) imageUrls.get(i);//No I18N
                            File file = new File(fileName);
                            String imageName = file.getName();
                            //If the attached linline image is missing then we could not send REPLY/FORWARD mail.
                            //Before to add the image in mime part, we are check whether the file exists.
                            logger.log(Level.FINE, "debug :: Going to add file name::{0}", file);
                            if (file.exists()) {
                                long currentTime = System.currentTimeMillis();
                                String contentId = "Image" + currentTime + i;//No i18N
                                String partId = "cid:Image" + currentTime + i;//No i18N
                                content = content.replaceAll((String) imageUrls.get(i), partId);
                                HashMap attMap = new HashMap();
                                attMap.put("imagename", imageName);
                                attMap.put("filename", fileName);
                                attMap.put("contentid", contentId);
                                ewsAttMap.add(attMap);
                            }//INLINE ISSUE
                            else {
                                logger.log(Level.INFO, "debug : The mentioned inline image does not exist in respective directory :: {0}", fileName);
                            }
                        }
                    }
                    description = content;
                    // In IE, there will be line spaceing and hence removing the spacing using style properties.
                    description = "<style>p { margin-top:0px; margin-bottom:0px;font-family: Arial, Helvetica, sans-serif;font-size:13px;}</style>" + description; // No I18N
                } catch (Exception exp) {
                    exp.printStackTrace();
                    logger.log(Level.INFO, "Error while adding inline images to mail content");
                }
            }
            if (mailServer.equalsIgnoreCase("ews")) {
                try {
                    DataObject ewsDO = DataAccessUtil.getInstance().get(OUTGOINGEWSSERVER.TABLE, (Criteria) null);
                    Row incomingRow = (Row) ewsDO.getRow(OUTGOINGEWSSERVER.TABLE);
                    String ewsURL = (String) incomingRow.get(OUTGOINGEWSSERVER.SERVERURL);
                    String ewsUsername = (String) incomingRow.get(OUTGOINGEWSSERVER.USERNAME);
                    String ewsPassword = (String) incomingRow.get(OUTGOINGEWSSERVER.USERPWD);

                    ExchangeService service = new ExchangeService();
                    URI uri = new URI(ewsURL);
                    service.setUrl(uri);
                    try
                    {
                        logger.log(Level.INFO, "!@#!#@ Going to set proxy for ews service");
                        logger.log(Level.INFO, "!@#!@# fetch proxyDetails ::");
                        HashMap<String, String> proxyDetails = HttpClientUtil.fetchProxyDetails();
                        logger.log(Level.INFO, "!@#!@# " + proxyDetails);
                        String proxyHost = proxyDetails.get("proxyHost");
                        String proxyPort = proxyDetails.get("proxyPort");
                        String proxyUsername = proxyDetails.get("proxyUsername");
                        String proxyPassword = proxyDetails.get("proxyPassword");
                        WebProxyCredentials webProxyCredentials = null;
                        if (!"".equals(proxyUsername) || !"".equals(proxyPassword)) {
                            int domainIndex = proxyUsername.contains("\\") ? proxyUsername.lastIndexOf("\\") : -1;
                            String domain = null;
                            if(domainIndex != -1)
                            {
                                domain = proxyUsername.substring(0, domainIndex);
                                proxyUsername = proxyUsername.substring(domainIndex + 1);
                            }
                            if (!"".equals(proxyUsername)) {
                                proxyPassword = "".equals(proxyPassword) ? null : proxyPassword;
                                logger.log(Level.INFO, "!@#!@# Going to set credentials for proxy - username ::"+proxyUsername+" :: password ::"+proxyPassword+" :: domain ::"+domain);
                                webProxyCredentials = new WebProxyCredentials(proxyUsername, proxyPassword, domain);
                            }
                        }
                        if (!"".equals(proxyHost) && !"".equals(proxyPort)) {
                            int proxyPortInt = Integer.parseInt(proxyPort);
                            logger.log(Level.INFO, "!@#!@# Going to set hostname and port for proxy - hostname ::"+proxyHost+" :: port ::"+proxyPortInt);
                            WebProxy webProxy = webProxyCredentials == null ? new WebProxy(proxyHost, proxyPortInt) : new WebProxy(proxyHost, proxyPortInt, webProxyCredentials);
                            service.setWebProxy(webProxy);
                        }
                    }
                    catch(Exception ex)
                    {
                        ex.printStackTrace();
                        logger.log(Level.INFO, "!@#!@# Exception while setting proxy for ews");
                    }
                    //SD-77145
                    ExchangeCredentials credentials;
                    int domainIndex = ewsUsername.indexOf("\\");
                    if(domainIndex != -1)
                    {
                        String domain = ewsUsername.substring(0, domainIndex);
                        ewsUsername = ewsUsername.substring(domainIndex +1);
                        credentials = new WebCredentials(ewsUsername, ewsPassword, domain);
                    }
                    else
                    {
                        credentials = new WebCredentials(ewsUsername, ewsPassword);
                    }
                    service.setCredentials(credentials);
                    if(isDebuggerEnabled) {
                        service.setTraceEnabled(true);
                        service.setTraceFlags(EnumSet.allOf(TraceFlags.class));
                        service.setTraceListener(new ITraceListener() {
                            public void trace(String traceType, String traceMessage) {
                                logger.log(Level.INFO, "Type:" + traceType + " Message:" + traceMessage);
                            }
                        });
                    }
                    EmailMessage emailMessage = new EmailMessage(service);

                    if (fromAddress != null) {
                        //setting fromaddress
                        EmailAddress fromEmailAddress = new EmailAddress(fromAddress);
                        emailMessage.setFrom(fromEmailAddress);
                        //setting toAddress
                        if(toAddress != null && !"".equals(toAddress))
                        {
                            String[] addresses = toAddress.split(",");
                            for(String address : addresses)
                            {
                                address = address.trim(); //SD-76807
                                if (address != null && !address.equals(""))
                                {
                                    emailMessage.getToRecipients().add(address);
                                }
                            }
                        }

                        //setting ccAddress

                        if(ccAddress != null && !"".equals(ccAddress))
                        {
                            String[] addresses = ccAddress.split(",");
                            for(String address : addresses)
                            {
                                if (address != null && !address.equals(""))
                                {
                                    emailMessage.getCcRecipients().add(address.trim());
                                }
                            }
                        }

                        //setting subject
                        emailMessage.setSubject(title);

                        // create and fill the first message part
                        MimeBodyPart mbp1 = new MimeBodyPart();
                        //for plaintext format
                        logger.log(Level.INFO, "contenttype::" + contentType);
                        if (contentType != null || !("text/plain").equals(contentType)) {
                            for (int i = 0; i < ewsAttMap.size(); i++) {
                                HashMap attMap = (HashMap) ewsAttMap.get(i);
                                FileAttachment fileAttachment = emailMessage.getAttachments().addFileAttachment((String) attMap.get("imagename"), (String) attMap.get("filename"));//NO I18N
                                fileAttachment.setIsInline(true);
                                fileAttachment.setContentId((String) attMap.get("contentid"));
                            }
                        }
                        /*
                            SD-78050 -> When passed contentType is not null, then body type is set as HTML irrespective
                            of the passed contentType. ie. Even if the contentType is text/plain BodyType is set as HTML.
                            Thus, bodyType is set based on the passed contentType.
                         */
                        if(contentType == null || "text/plain".equals(contentType))
                        {
                            emailMessage.setBody(new MessageBody(BodyType.Text, description));
                        }
                        else
                        {
                            emailMessage.setBody(new MessageBody(BodyType.HTML, description));
                        }
                        if (fileAttachments != null) {
                            logger.log(Level.INFO, "fileAttachments : {0}", Arrays.asList(fileAttachments));
                            for (int i = 0; i < fileAttachments.length; i++) {
                                String attPath = fileAttachments[i];
                                File file = new File(attPath);
                                logger.log(Level.INFO, "file.exists() : {0} file.isFile() : {1}", new String[]{String.valueOf(file.exists()), String.valueOf(file.isFile())});
                                if ((attPath != null) && (!attPath.equals("")) && file.exists() && file.isFile()) {
                                    //SD-77427
                                    String fileName = file.getName();
                                    if( reportTitle != null )
                                    {
                                        reportTitle = reportTitle.replaceAll("/", "-");//No I18N
                                        reportTitle = reportTitle + fileName.substring(fileName.lastIndexOf("."));//No I18N
                                        fileName = reportTitle;
                                    }
                                    emailMessage.getAttachments().addFileAttachment(fileName, attPath);
                                }
                            }
                        }
                        //SD-73197
                        // Send message
//                        if (inReplyTo != null) {
//                            logger.log(Level.FINE, "IRT is not null so setting it to mess obj");
//                            emailMessage.setInReplyTo(inReplyTo);
//                        }
                        emailMessage.save();
                        emailMessage.load();
                        messageID = emailMessage.getInternetMessageId();
                        emailMessage.sendAndSaveCopy();
                        logger.log(Level.INFO, " message {0}", messageID);
                    }

                } catch (Exception e) {
                    e.printStackTrace();
                    ServiceDeskException sde = new ServiceDeskException("Mail sending failed by EWS.", e);//No I18N
                    sde.setErrorCode(ServiceDeskErrorCode.ER_MAIL_SENDING_FAILED);
                    throw sde;
                }
                logger.log(Level.INFO, "### Notification sent by EWS ###");
                return messageID;
            } else {
                String host = null;
                String alternateHost = null;
                Long port = null;
                // Get system properties
                Properties props = new Properties(); //SD-72424
                logger.log(Level.FINE, "Sys props : {0}", props);
                String emailType = null;
                boolean tlsEnabled = false;
                boolean isAuthRequired = false;
                //SD-21920-SMTPS support for outgoing
                Criteria criteria = null;
                try {
                    DataObject outgoingDO = MailUtilities.getInstance().getOutgoingMailServerDetails();
                    Row outgoingRow = outgoingDO.getRow(OUTGOINGMAILSERVER.TABLE);
                    host = (String) outgoingRow.get(OUTGOINGMAILSERVER.HOSTNAME);
                    alternateHost = String.valueOf(outgoingRow.get(OUTGOINGMAILSERVER.ALTERNATEHOSTNAME));
                    Long portId = (Long) outgoingRow.get(OUTGOINGMAILSERVER.PORTID);
                    logger.log(Level.FINE, "host -----> {0} port id ---------> {1}", new Object[]{host, portId});

                    if (portId != null) {
                        DataObject portDO = MailUtilities.getInstance().getMailPortDetails();
                        Criteria criteria1 = new Criteria(Column.getColumn(MAILPORTDETAILS.TABLE, MAILPORTDETAILS.PORTID), portId, QueryConstants.EQUAL);
                        logger.log(Level.FINEST, "Port criteria : {0}", criteria1);
                        Row portRow = portDO.getRow(MAILPORTDETAILS.TABLE, criteria1);
                        port = (Long) portRow.get(MAILPORTDETAILS.PORT);
                        emailType = (String) portRow.get(MAILPORTDETAILS.EMAILTYPE);
                        tlsEnabled = (Boolean) portRow.get(MAILPORTDETAILS.TLSENABLED);
                        logger.log(Level.FINE, " emailType ---------> " + emailType + " tlsEnabled ---------> " + tlsEnabled);
                    }
                } catch (Exception e) {
                    ServiceDeskException sde = new ServiceDeskException("Exception while trying to trying to get the outgoing mail sever DNS Name/IP Address.", e);//No I18N
                    sde.setErrorCode(ServiceDeskErrorCode.ER_FETCHING_DATA);
                    throw sde;
                }

                if (host == null || host.equals("")) {
                    ServiceDeskException sde = new ServiceDeskException("Outgoing mail server name is not configured properly. It could be null or empty.");//No I18N
                    sde.setErrorCode(ServiceDeskErrorCode.ER_OUTGOING_MAILSERVER_NAME);
                    throw sde;
                }
                if (fromAddress == null || fromAddress.equals("")) {
                    ServiceDeskException sde = new ServiceDeskException("Problem occured while fetching the from address for the notification to be sent.");//No I18N
                    sde.setErrorCode(ServiceDeskErrorCode.ER_GETTING_FROM_ADDRESS);
                    throw sde;
                }
                //SD-73515
                if(CacheUtil.getFromCache(CacheUtil.ALTERNATE_MAIL_SERVER) != null)
                {
                    props.put("mail.host", alternateHost);//No I18N
                    props.put("mail.smtp.host", alternateHost);//No I18N
                }
                else {
                    props.put("mail.host", host);//No I18N
                    props.put("mail.smtp.host", host);//No I18N
                }
                if(sendPartial)
                {
                	props.put("mail.smtp.sendpartial", "true");
                }
                if (port != null) {
                    props.put("mail.smtp.port", port.toString());//No I18N
                }
                try {
                    if (ServiceDeskUtil.getInstance().isMSPLicense()) {
                        props.put("mail.smtp.from", senderAddress);//No I18N
                    }
                } catch (Exception x) {
                    logger.log(Level.FINE, "Error while putting senderAddress in from");
                }
                if (tlsEnabled) {
                    props.put("mail.smtp.starttls.enable", "true"); //No I18N
                } else {
                    if (props.getProperty("mail.smtp.starttls.enable") != null) {
                        props.remove("mail.smtp.starttls.enable");//No I18N
                    }
                }
                if (emailType != null && "smtps".equals(emailType)) {
                    props.setProperty("mail.smtp.socketFactory.class", "javax.net.ssl.SSLSocketFactory");//No I18N
                    props.setProperty("mail.smtp.socketFactory.port", port.toString());//No I18N
                    props.setProperty("mail.smtp.socketFactory.fallback", "false");//No I18N
                }
                // Get session
                Session session;
                try {
                    logger.log(Level.INFO, "Going to check any additional property for mail sending in MailProperties table");
                    MailUtilities.getInstance().checkAndAddMailProperties(emailType, props);
                    SMTPAuthenticator authenticator = MailUtilities.getInstance().getSMTPAuthenticator(props);
                    //If Authentication is not required for the outgoing mails the authenticator will be null
                    session = Session.getInstance(props, authenticator);

                } catch (Exception e) {
                    ServiceDeskException sde = new ServiceDeskException("Exception while trying to trying to get the SMTP Authenticator info.", e);//No I18N
                    sde.setErrorCode(ServiceDeskErrorCode.ER_FETCHING_DATA);
                    throw sde;
                }
                session.setDebug(isDebuggerEnabled);

                // Define message
                MimeMessage message = new MimeMessage(session);
                InternetAddress ia = null;
                try {
                    ia = new InternetAddress(fromAddress);
                    //To set the personal name..
                    if (!(fromName == null || fromName.equals(""))) {
                        ia.setPersonal(fromName, "UTF-8");//No I18N
                    }
                } catch (javax.mail.internet.AddressException ae) {
                    ServiceDeskException sde = new ServiceDeskException("Wrongly formatted from address. Check for correct format.", ae);//No I18N
                    sde.setErrorCode(ServiceDeskErrorCode.ER_WRONGLY_FORMATTED_ADDRESS);
                    throw sde;
                } catch (UnsupportedEncodingException ue) {
                    ServiceDeskException sde = new ServiceDeskException("Unsupported Encoding of personal name. Check for correct format.", ue);//No I18N
                    //sde.setErrorCode(ServiceDeskErrorCode.ER_WRONGLY_FORMATTED_ADDRESS);
                    throw sde;
                }

                try {
                    if (ia != null) {
                        message.setFrom(ia);
                        //message.addRecipients(Message.RecipientType.TO,toAddress);
                        if (toAddress != null) {
                            InternetAddress[] tos = InternetAddress.parse(toAddress);
                            int tolen = tos.length;
                            for (int loop = 0; loop < tolen; loop++) {
                                InternetAddress too = tos[loop];
                                too.setPersonal(too.getPersonal(), "UTF-8");//No I18N
                            }
                            message.addRecipients(Message.RecipientType.TO, tos);
                        }
                        if (ccAddress != null) {
                            //message.addRecipients(Message.RecipientType.CC,ccAddress);
                            InternetAddress[] tos = InternetAddress.parse(ccAddress);
                            int tolen = tos.length;
                            for (int loop = 0; loop < tolen; loop++) {
                                InternetAddress too = tos[loop];
                                too.setPersonal(too.getPersonal(), "UTF-8");//No I18N
                            }
                            message.addRecipients(Message.RecipientType.CC, tos);
                        }
                        message.setSubject(title, "UTF-8");//No I18N
                        //message.setText(description);
                        // create and fill the first message part
                        MimeBodyPart mbp1 = new MimeBodyPart();
                        if (contentType != null) {
                            mbp1.setContent(description, contentType + ";charset=\"UTF-8\"");//No I18N
                        } else {
                            mbp1.setContent(description, "text/plain;charset=\"UTF-8\"");//No I18N
                        }
                        // create the second message part
                        // attach the file to the message
                        // First delimit the Files using the ,
                        //Multipart mp = new MimeMultipart("related");//No I18N
                        //SD-12654 : To fix the problem in viewing the attachment in outlook 2003,when an email is sent from SDP
                        //through exchange 2007.Changing the MimeMultipart to "mixed".

                        // SD-60717 Issue with outlook 2007 / when mail is sent from SDP with inline images,the mail is recieved without inline images in Outlook.
                        String subTypeValue = "mixed"; // NO I18N
                        try {
                            subTypeValue = GlobalConfigUtil.getInstance().getGlobalConfigValue("SubType", "MimeMultipart", "mixed"); // NO I18N
                        } catch (Exception ex) {
                            logger.log(Level.SEVERE, "Exception is getting while fetching GlobalConfig table MimeMultipart row {0}", ex); // No I18N
                        }
                        Multipart mp = new MimeMultipart(subTypeValue);
                        mp.addBodyPart(mbp1);
                        // Will iterate through the inline images mime parts and add them here.
                        for (int j = 0; j < parts.size(); j++) {
                            mp.addBodyPart((MimeBodyPart) parts.get(j));
                        }

                        if (inlineAttachments != null && inlineAttachments.size() > 0) {
                            logger.log(Level.FINE, "InlineAttachments received: {0}", inlineAttachments);
                            for (Iterator it = inlineAttachments.keySet().iterator(); it.hasNext(); ) {
                                String content_id = (String) it.next();
                                MimeBodyPart embedImage2 = new MimeBodyPart();
                                FileDataSource ds2 = new FileDataSource(new File((String) inlineAttachments.get(content_id)));
                                embedImage2.setDataHandler(new DataHandler(ds2));
                                embedImage2.setHeader("Content-ID", "<" + content_id + ">");//No I18N
                                mp.addBodyPart(embedImage2);
                            }
                            inlineAttachments = null;
                        }
                        if (fileAttachments != null) {
                            logger.log(Level.INFO, "fileAttachments : {0}", Arrays.asList(fileAttachments));
                            for (int i = 0; i < fileAttachments.length; i++) {
                                String att = fileAttachments[i];
                                File file = new File(att);
                                logger.log(Level.INFO, "file.exists() : {0} file.isFile() : {1}", new String[]{new Boolean(file.exists()).toString(), new Boolean(file.isFile()).toString()});
                                if ((att != null) && (!att.equals("")) && file.exists() && file.isFile()) {
                                    MimeBodyPart mbp2 = new MimeBodyPart();
                                    FileDataSource fds = new FileDataSource(att);
                                    mbp2.setDataHandler(new DataHandler(fds));
                                    if (reportTitle != null) {
                                        reportTitle = reportTitle.replaceAll("/", "-");//No I18N
                                        String tempFileName = fds.getName();
                                        reportTitle = reportTitle + tempFileName.substring(tempFileName.lastIndexOf("."));//No I18N
                                        mbp2.setFileName(MimeUtility.encodeText(reportTitle));
                                    } else {
                                        mbp2.setFileName(MimeUtility.encodeText(fds.getName()));
                                    }
                                    // create the Multipart and its parts to it
                                    mp.addBodyPart(mbp2);
                                }
                            }
                        }
                        message.setContent(mp);
                        logger.log(Level.INFO, "The contenttype has been set in the message");
                        // Send message
                        //To Set TimeStamp for outgoing message
                        Date currentDate = new Date();
                        message.setSentDate(currentDate);

                        //SD-73197
//                        if (inReplyTo != null) {
//                            logger.log(Level.FINE, "IRT is not null so setting it to mess obj");
//                            message.setHeader("In-Reply-To", inReplyTo);//No I18N
//                        }
                        try {
                            Transport.send(message);
                        }
                        //SD-73515
                        catch(MailConnectException mce)
                        {
                            Transport tr = null;
                            try
                            {
                                String currentHost = props.getProperty("mail.smtp.host");
                            /*
                                Alternate mail server shouldn't be null or ""
                                It shouldn't be the same as the primary mail server.
                             */
                                if(CacheUtil.getFromCache(CacheUtil.ALTERNATE_MAIL_SERVER) == null && alternateHost != null && !"".equals(alternateHost) && !(currentHost.equals(alternateHost)))
                                {
                                    logger.log(Level.INFO, "Connectivity problem while sending mails through mail server - "+currentHost);
                                    mce.printStackTrace();
                                    logger.log(Level.INFO, "Going to send mails through secondary mail server - "+alternateHost);
                                    props.setProperty("mail.host", alternateHost);
                                    props.setProperty("mail.smtp.host", alternateHost);
                                    tr = session.getTransport("smtp");  //No I18N
                                    ArrayList tableNames = new ArrayList();
                                    tableNames.add(OUTGOINGMAILSERVER.TABLE);
                                    try
                                    {
                                        CacheUtil.addToCache(CacheUtil.ALTERNATE_MAIL_SERVER, alternateHost, tableNames);
                                    }
                                    catch(Exception ex)
                                    {
                                        logger.log(Level.INFO, "Exception while storing the cache value or sending error notification");
                                        ex.printStackTrace();
                                    }
                                    tr.connect();
                                    tr.sendMessage(message, message.getAllRecipients());
                                    try
                                    {
                                        AeSdpBridgeInterface aeSdpBridgeInterface = ((AeSdpBridgeInterface) Class.forName("com.adventnet.servicedesk.utils.AeSdpBridgeImpl").newInstance());
                                        aeSdpBridgeInterface.notifySystemError("ERROR : Connectivity problem with primary mail server", "Couldn't connect the primary mail server - "+currentHost+". Hence, mails will be sent through the secondary mail server - "+alternateHost);
                                    }
                                    catch(Exception ex)
                                    {
                                        logger.log(Level.INFO, "Exception while storing the cache value or sending error notification");
                                        ex.printStackTrace();
                                    }
                                }
                                else
                                {
                                    ServiceDeskException sde = new ServiceDeskException("Connectivity problem while sending mails through "+currentHost);//No I18N
                                    sde.setErrorCode(ServiceDeskErrorCode.ER_MAIL_SENDING_FAILED);
                                    throw sde;
                                }

                            }
                            catch(MailConnectException mc)
                            {
                                logger.log(Level.SEVERE, "Both mail servers are failed to connect.");
                                mc.printStackTrace();
                                ServiceDeskException sde = new ServiceDeskException("Both mail servers are failed to connect.");//No I18N
                                sde.setErrorCode(ServiceDeskErrorCode.ER_MAIL_SENDING_FAILED);
                                throw sde;
                            }
                            catch(MessagingException ex)
                            {
                                logger.log(Level.INFO, "Exception while connecting through alternate mail server");
                                ex.printStackTrace();
                                ServiceDeskException sde = new ServiceDeskException("Exception while sending mails through secondary mail server");  //No I18N
                                sde.setErrorCode(ServiceDeskErrorCode.ER_MAIL_SENDING_FAILED);
                                throw sde;
                            }
                            finally
                            {
                                if(tr != null)
                                {
                                    tr.close();
                                }
                            }
                        }
                        catch(javax.mail.MessagingException me)
                        {
                        boolean invalidAddress=false;
                        String failedAddresses="";
                        while(sendPartial && me.getNextException()!=null && me.getNextException() instanceof SMTPAddressFailedException) 
                        {
                        		invalidAddress=true;
                        		SMTPAddressFailedException e=(SMTPAddressFailedException)me.getNextException(); 
                        		InternetAddress address=e.getAddress();
                        		if(address!=null)
                        		{
                        			if(failedAddresses.equals(""))
                        			{
                        				failedAddresses=address.toString();
                        			}
                        			else
                        			{
                        				failedAddresses=failedAddresses+","+address;
                        			}
                        		}
                        		me=e;
  
                        } 
                    	if(!"".equals(failedAddresses))
                		{
                			String logTitle="Error while Sending mail(Subject-"+title+")";//NO I18N
                			if(module!=null && moduleId!=null)
                			{
                				logTitle=logTitle+" in "+module+" id-"+moduleId; //NO I18N
                			}
                			serviceDeskUtil.populateSystemLog("Notification", "mail", logTitle,"Invalid Email Id(s)-"+failedAddresses, serviceDeskUtil.ERROR,serviceDeskUtil.UPDATE);
                		}
                        if(!invalidAddress)
                        {
                        	throw me;
                        }
                        }
                        messageID = message.getMessageID();
                        logger.log(Level.INFO, " message {0}", messageID);
                    } else {
                        ServiceDeskException sde = new ServiceDeskException("Wrongly formatted from address. Check for correct format.");//No I18N
                        sde.setErrorCode(ServiceDeskErrorCode.ER_WRONGLY_FORMATTED_ADDRESS);
                        throw sde;
                    }
                } catch (javax.mail.MessagingException me) {
                    me.printStackTrace();
                    ServiceDeskException sde = new ServiceDeskException("Mail sending failed.", me);//No I18N
                    sde.setErrorCode(ServiceDeskErrorCode.ER_MAIL_SENDING_FAILED);
                    throw sde;
                } catch (java.io.UnsupportedEncodingException e) {
                    e.printStackTrace();
                    ServiceDeskException sde = new ServiceDeskException("Mail sending failed due to UnsupportedEncodingException.", e);//No I18N
                    sde.setErrorCode(ServiceDeskErrorCode.ER_MAIL_SENDING_FAILED);
                    throw sde;
                }
            }
        }
        return messageID;
    }
    public String sendMailNotification(String toAddress, String title, String description, String ccAddress, String contentType, String[] fileAttachments, Long userId, HashMap inlineAttachments) throws ServiceDeskException
    {
        this.inlineAttachments = inlineAttachments;
        return sendMailNotification(toAddress, title, description, ccAddress, contentType, fileAttachments, userId);
    }
    public Long populateNotificationTable(Long toID, Long fromID, String desc, String content, String notificationType, String messageID) throws ServiceDeskException
    {
        return populateNotificationTable(toID, fromID, desc, content, notificationType, messageID, null, null);
    }

    public Long populateNotificationTable(Long toID, Long fromID, String desc, String content, String notificationType, String messageID, String toAddress) throws ServiceDeskException
    {
        return populateNotificationTable(toID, fromID, desc, content, notificationType, messageID, toAddress, null);
    }

    public Long populateNotificationTable(Long toID, Long fromID, String desc, String content, String notificationType, String messageID, String toAddress, String ccAddress) throws ServiceDeskException
    {
        return populateNotificationTable(toID, fromID, desc, content, notificationType, messageID, toAddress, ccAddress, null, null);
    }

    public Long populateNotificationTable(Long toID, Long fromID, String desc, String content, String notificationType, String messageID, String toAddress, String ccAddress, String fileAttachments, String attSize) throws ServiceDeskException
    {
        return populateNotificationTable(toID, fromID, desc, content, notificationType, messageID, toAddress, ccAddress, fileAttachments, attSize, null);
    }

    /**
     *
     * @param toUserID
     * @param fromID
     * @param desc
     * @param content
     * @param notificationType
     * @param messageID
     * @param toAddress
     * @param ccAddress
     * @param fileAttachments
     * @param attSize
     * @param module
     * @return
     * @throws ServiceDeskException
     */
    public Long populateNotificationTable(Long toUserID,Long fromID,String desc,String content,String notificationType,String messageID,String toAddress,String ccAddress,String fileAttachments,String attSize,String module) throws ServiceDeskException
    {
        return populateNotificationTable(toUserID, fromID, desc, content, notificationType, messageID, toAddress, ccAddress, fileAttachments, attSize, module,true);
    }
    public Long populateNotificationTable(Long toUserID,Long fromID,String desc,String content,String notificationType,String messageID,String toAddress,String ccAddress,String fileAttachments,String attSize,String module, boolean isPublic) throws ServiceDeskException {

        Long notificationID = null;
        try
        {
            if (fromID == null)
            {
                fromID = (Long) dbUtil.getResultObject("AaaUser", new Criteria(Column.getColumn(AAAUSER.TABLE, AAAUSER.FIRST_NAME), "System", QueryConstants.EQUAL), "USER_ID");//No I18N
            }

            logger.log(Level.FINE, " fromID {0}", fromID);
            long currentTime = System.currentTimeMillis();
            DataObject notifyDO = ResourcesUtil.getInstance().constructDataObject();
            Row notifyRow = new Row(NOTIFICATION.TABLE);
            if (!ServiceDeskUtil.getInstance().isHtmlEnabledForNotification())
            {
                content = ServiceDeskUtil.getInstance().getHTMLStrippedValue(content);
                content = content.replaceAll("\n", "<br>");//No I18N
            }
        /* The following code has been added to replace all cid:AnnounceIcn and cid:SolnIcn with
          the respective paths before saving in 'NotificationToDesc' table. This is to ensure that the
          announcement and solution icons are displayed properly in the Notification content displayed
          in the WorkOrder details page.
        */
            if(content.indexOf("cid:AnnounceIcn")>0)
            {
                content = content.replaceAll("cid:AnnounceIcn", "/images/search-annuncmnt-icn.png");	//No I18N
            }
            if(content.indexOf("cid:SolnIcn")>0)
            {
                content = content.replaceAll("cid:SolnIcn", "/images/search-solutin-icn.png");		//No I18N
            }
            notifyRow.set(NOTIFICATION.NOTIFICATIONDESCRIPTION, "");
            notifyRow.set(NOTIFICATION.NOTIFICATIONTYPE, notificationType);
            notifyRow.set(NOTIFICATION.NOTIFICATIONTITLE, desc);
            notifyRow.set(NOTIFICATION.NOTIFICATIONDATE, new Long(currentTime));
            notifyRow.set(NOTIFICATION.SENDERID, fromID);
            notifyRow.set(NOTIFICATION.RECIPIENTID, toUserID);
            notifyRow.set(NOTIFICATION.MESSAGEID, messageID);
            notifyRow.set(NOTIFICATION.ISPUBLIC, isPublic);
            //Updating hasAttachment column
            if (fileAttachments != null && (!fileAttachments.equals("")))
            {
                notifyRow.set("HASATTACHMENT",Boolean.TRUE); //No I18N
            }
            notifyDO.addRow(notifyRow);

            Boolean addDescAttachment=false;
            Row notifyToDesc = new Row(NOTIFICATIONTODESC.TABLE);
            notifyToDesc.set(NOTIFICATIONTODESC.NOTIFICATIONID, notifyRow.get(NOTIFICATION.NOTIFICATIONID));

            //Notification description length check only for request module.
            if("Request".equals(module))
            {
                int descsize = (int)ServiceDeskUtil.getInstance().getConvNotifDesecriptionSize();
                if (content.length() < descsize)
                {
                    notifyToDesc.set(NOTIFICATIONTODESC.DESCRIPTION, content);
                    notifyToDesc.set("ATTACHMENTID", null);//No i18N
                }
                else
                {
                    notifyToDesc.set(NOTIFICATIONTODESC.DESCRIPTION, StringUtil.getInstance().getUnHTMLTrimmedString(content, descsize));
                    addDescAttachment=true;
                }
            }
            else
            {
                notifyToDesc.set(NOTIFICATIONTODESC.DESCRIPTION, content);
            }

            notifyDO.addRow(notifyToDesc);

            Vector toVec = new Vector();
            if (toAddress != null && !toAddress.equals(""))
            {
                toVec = strUtil.makeVector(toAddress, ",");//No I18N
                for (int i = 0; i < toVec.size(); i++)
                {
                    try
                    {
                        Row notRecp1 = new Row(NOTIFICATION_RECIPIENTS.TABLE);
                        notRecp1.set(NOTIFICATION_RECIPIENTS.NOTIFICATIONID, notifyRow.get(NOTIFICATION.NOTIFICATIONID));
                        String toID = (String) toVec.get(i);
                        notRecp1.set(NOTIFICATION_RECIPIENTS.RECIPIENT_EMAIL, toID.toLowerCase());
                        notRecp1.set(NOTIFICATION_RECIPIENTS.TO_CC_BCC, "TO");//No I18N
                        notifyDO.addRow(notRecp1);
                    }
                    catch (Exception e)
                    {
                        logger.log(Level.INFO, " Exception that might be thrown while trying to add duplicate mail alias will be left free.");
                        continue;
                    }
                }
            }
            if (ccAddress != null && !ccAddress.equals(""))
            {
                Vector ccVec = strUtil.makeVector(ccAddress, ",");//No I18N
                ccVec = strUtil.makeVector(ccAddress, ",");//No I18N
                for (int i = 0; i < ccVec.size(); i++)
                {
                    for (int j = 0; j < toVec.size(); j++)
                    {
                        if (ccVec.get(i) == toVec.get(j))
                        {
                            ccVec.remove(ccVec.get(i));
                            i--;
                            continue;
                        }
                    }
                    try
                    {
                        Row notRecp2 = new Row(NOTIFICATION_RECIPIENTS.TABLE);
                        notRecp2.set(NOTIFICATION_RECIPIENTS.NOTIFICATIONID, notifyRow.get(NOTIFICATION.NOTIFICATIONID));
                        String ccID = (String) ccVec.get(i);
                        notRecp2.set(NOTIFICATION_RECIPIENTS.RECIPIENT_EMAIL, ccID.toLowerCase());
                        notRecp2.set(NOTIFICATION_RECIPIENTS.TO_CC_BCC, "CC");//No I18N
                        notifyDO.addRow(notRecp2);
                    }
                    catch (Exception e)
                    {
                        logger.log(Level.INFO, " Exception that might be thrown while trying to add duplicate mail alias will be left free.");
                        continue;
                    }
                }
            }
            ResourcesUtil.getInstance().add(notifyDO);


            //Moving the extra description to attachment
            if (addDescAttachment)
            {
                // Description will be moved as attached if the description content length is more than 64K
                moveNotificationDescriptionAsAttachment(content,notifyDO);
            }



            MailUtilities.getInstance().addToMessageIdCache(messageID, new Long(currentTime));
            if (fileAttachments != null && (!fileAttachments.equals("")))
            {
                if (module != null && module != "" && module.equals("PONotifications"))
                {
                    AttachmentUtil.getInstance().addAttachments(fileAttachments, attSize, module, fromID, (Long) notifyRow.get(NOTIFICATION.NOTIFICATIONID), currentTime);
                }
                else
                {
                    AttachmentUtil.getInstance().addAttachments(fileAttachments, attSize, "Notifications", fromID, (Long) notifyRow.get(NOTIFICATION.NOTIFICATIONID), currentTime);//No I18N
                }
            }
            notificationID = (Long) notifyRow.get(NOTIFICATION.NOTIFICATIONID);
            logger.log(Level.FINE, " notificationID {0}", notificationID);
        }
        catch (Exception e)
        {
            ServiceDeskException sde = new ServiceDeskException("Exception while trying to populate table Notification, for the sent notification.", e);//No I18N
            sde.setErrorCode(ServiceDeskErrorCode.ER_POPULATING_NOTIFICATION_TABLE);
            throw sde;
        }
        return notificationID;
    }

    /**
     *
     * @param time
     * @param dateStr
     * @return
     */
    public static String formateDate(Long time, String dateStr) throws Exception
    {
        if (time != null && time > 0)
        {
            Date dt = new Date(time.longValue());
            SimpleDateFormat sd = new SimpleDateFormat(dateStr, Locale.US);
            return sd.format(dt);
        }
        else
        {
            return "-";//No I18N
        }
    }

    /**
     *
     * @param moduleName
     * @param id
     * @return
     */
    public SelectQueryImpl getSelectQuery(String moduleName, Object id)
    {
        SelectQueryImpl sq = null;

        if (moduleName.equals("Request") || moduleName.equals("Change") || moduleName.equals("Request_FR") || moduleName.equals("Leave")) // No I18N
        {
            try
            {
                NotificationUtilInterface nui = ((NotificationUtilInterface) Class.forName("com.adventnet.servicedesk.helpdesk.util.HdNotificationUtil").newInstance());//No I18N
                sq = nui.getQuery4Notification(moduleName, id);
            }
            catch (Exception e)
            {
                logger.log(Level.SEVERE, "Exception while trying to get Request Select Query ");
            }
        }
        else if (moduleName.equals("PurchaseOrder"))
        {
            sq = new SelectQueryImpl(Table.getTable(PURCHASEORDER.TABLE));

            String column1[] = {PURCHASEORDER.PURCHASEORDERID};
            Join join1 = new Join(PURCHASEORDER.TABLE,PURCHASEORDERITEM.TABLE,column1,column1,Join.LEFT_JOIN);
            sq.addJoin(join1);

            String column21[] = {PURCHASEORDER.REQUESTERID};
            String column22[] = {SDUSER.USERID};
            Join join2 = new Join(PURCHASEORDER.TABLE,SDUSER.TABLE,column21, column22, Join.LEFT_JOIN);
            sq.addJoin(join2);

            String column31[] = {SDUSER.USERID};
            String column32[] = {AAAUSER.USER_ID};
            Join join3 = new Join(SDUSER.TABLE,AAAUSER.TABLE,column31, column32, Join.LEFT_JOIN);
            sq.addJoin(join3);

            String column4[] = {POSTATUS.STATUSID};
            Join join4 = new Join(PURCHASEORDER.TABLE,POSTATUS.TABLE,column4, column4, Join.LEFT_JOIN);
            sq.addJoin(join4);

            String column5[] = {PURCHASECATEGORY.CATEGORYID};
            Join join5 = new Join(PURCHASEORDER.TABLE,PURCHASECATEGORY.TABLE,column5, column5, Join.LEFT_JOIN);
            sq.addJoin(join5);

            String column6[] = {VENDORDEFINITION.VENDORID};
            Join join6 = new Join(PURCHASEORDER.TABLE,VENDORDEFINITION.TABLE,column6, column6, Join.LEFT_JOIN);
            sq.addJoin(join6);

            String column71[] = {VENDORDEFINITION.VENDORID};
            String column72[] = {SDORGANIZATION.ORG_ID};
            Join join7 = new Join(VENDORDEFINITION.TABLE,SDORGANIZATION.TABLE,column71, column72, Join.LEFT_JOIN);
            sq.addJoin(join7);

//                String column8[] = {COMPONENTVENDOR.COMPONENTVENDORID};
//                Join join8 = new Join(PURCHASEORDERITEM.TABLE,COMPONENTVENDOR.TABLE,column8, column8, Join.LEFT_JOIN);
//                sq.addJoin(join8);

            String column9[] = {COMPONENTDEFINITION.COMPONENTID};
            Join join9 = new Join(PURCHASEORDERITEM.TABLE,COMPONENTDEFINITION.TABLE,column9, column9, Join.LEFT_JOIN);
            sq.addJoin(join9);

            String column101[] = {SDORGANIZATION.ORG_ID};
            String column102[] = {SDORGCONTACTINFO.ORG_ID};
            Join join10 = new Join(SDORGANIZATION.TABLE, SDORGCONTACTINFO.TABLE, column101,column102, Join.LEFT_JOIN);
            sq.addJoin(join10);

            String column111[] = {SDORGANIZATION.ORG_ID};
            String column112[] = {SDORGPOSTALADDR.ORG_ID};
            Join join11 = new Join(SDORGANIZATION.TABLE, SDORGPOSTALADDR.TABLE, column111,column112, Join.LEFT_JOIN);
            sq.addJoin(join11);

            String column121[] = {SDORGCONTACTINFO.CONTACTINFO_ID};
            String column122[] = {AAACONTACTINFO.CONTACTINFO_ID};
            Join join12 = new Join(SDORGCONTACTINFO.TABLE, AAACONTACTINFO.TABLE, column121,column122, Join.LEFT_JOIN);
            sq.addJoin(join12);

            String column131[] = {SDORGPOSTALADDR.POSTALADDR_ID};
            String column132[] = {AAAPOSTALADDRESS.POSTALADDR_ID};
            Join join13 = new Join(SDORGPOSTALADDR.TABLE, AAAPOSTALADDRESS.TABLE, column131,column132, Join.LEFT_JOIN);
            sq.addJoin(join13);
            String column141[] = {PURCHASEORDER.PURCHASEORDERID};
            String column142[] = {PURCHASEORDER_FIELDS.PURCHASEORDERID};
            Join join14 = new Join(PURCHASEORDER.TABLE,PURCHASEORDER_FIELDS.TABLE,column141, column142, Join.LEFT_JOIN);
            sq.addJoin(join14);

            sq.addSelectColumn(Column.getColumn(PURCHASEORDER.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(PURCHASEORDERITEM.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(POSTATUS.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(PURCHASECATEGORY.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(SDUSER.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(SDORGANIZATION.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(AAAUSER.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(COMPONENTDEFINITION.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(COMPONENTVENDOR.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(VENDORDEFINITION.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(SDORGCONTACTINFO.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(SDORGPOSTALADDR.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(AAACONTACTINFO.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(AAAPOSTALADDRESS.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(PURCHASEORDER_FIELDS.TABLE,"*"));
            sq.setCriteria(new Criteria(Column.getColumn(PURCHASEORDER.TABLE,PURCHASEORDER.PURCHASEORDERID),id,QueryConstants.EQUAL));
        }
        else if(moduleName.equals("Contract"))
        {
            sq = new SelectQueryImpl(Table.getTable(MAINTENANCECONTRACT.TABLE));

            String column1[] = {MAINTENANCECONTRACT.CONTRACTID};
            Join join1 = new Join(MAINTENANCECONTRACT.TABLE,CONTRACTDETAILS.TABLE,column1, column1, Join.LEFT_JOIN);
            sq.addJoin(join1);

            String column21[] = {MAINTENANCECONTRACT.MAINTENANCEVENDOR};
            String column22[] = {VENDORDEFINITION.VENDORID};
            Join join2 = new Join(MAINTENANCECONTRACT.TABLE,VENDORDEFINITION.TABLE,column21, column22, Join.LEFT_JOIN);
            sq.addJoin(join2);

            String column31[] = {VENDORDEFINITION.VENDORID};
            String column32[] = {SDORGANIZATION.ORG_ID};
            Join join3 = new Join(VENDORDEFINITION.TABLE,SDORGANIZATION.TABLE,column31, column32, Join.LEFT_JOIN);
            sq.addJoin(join3);

            String column4[] = {CONTRACTSTATUS.STATUSID};
            Join join4 = new Join(MAINTENANCECONTRACT.TABLE,CONTRACTSTATUS.TABLE,column4, column4, Join.LEFT_JOIN);
            sq.addJoin(join4);

            String column51[] = {MAINTENANCECONTRACT.CREATEDBY};
            String column52[] = {SDUSER.USERID};
            Join join5 = new Join(MAINTENANCECONTRACT.TABLE,SDUSER.TABLE,column51, column52, Join.LEFT_JOIN);
            sq.addJoin(join5);

            String column61[] = {SDUSER.USERID};
            String column62[] = {AAAUSER.USER_ID};
            Join join6 = new Join(SDUSER.TABLE,AAAUSER.TABLE,column61, column62, Join.LEFT_JOIN);
            sq.addJoin(join6);

            String resourceId[] = {RESOURCES.RESOURCEID};
            Join join7 = new Join(CONTRACTDETAILS.TABLE,RESOURCES.TABLE,resourceId, resourceId, Join.LEFT_JOIN);
            sq.addJoin(join7);

            String column8[] = {COMPONENTDEFINITION.COMPONENTID};
            Join join8 = new Join(RESOURCES.TABLE,COMPONENTDEFINITION.TABLE,column8, column8, Join.LEFT_JOIN);
            sq.addJoin(join8);

            String column91[] = {MAINTENANCECONTRACT.CONTRACTID};
            String column92[] = {CONTRACT_FIELDS.CONTRACTID};
            Join join9 = new Join(MAINTENANCECONTRACT.TABLE,CONTRACT_FIELDS.TABLE,column91, column92, Join.LEFT_JOIN);
            sq.addJoin(join9);

            //if AaaPostalAddress is added the coresponding changes have to made in the parsing logic for retriving the value from db for notification.
            sq.addSelectColumn(Column.getColumn(MAINTENANCECONTRACT.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(CONTRACTDETAILS.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(VENDORDEFINITION.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(SDORGANIZATION.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(CONTRACTSTATUS.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(SDUSER.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(AAAUSER.TABLE,"*"));
            //sq.addSelectColumn(Column.getColumn(ASSETDETAILS.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(RESOURCES.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(COMPONENTDEFINITION.TABLE,"*"));
            sq.addSelectColumn(Column.getColumn(CONTRACT_FIELDS.TABLE,"*"));
            sq.setCriteria(new Criteria(Column.getColumn(MAINTENANCECONTRACT.TABLE,MAINTENANCECONTRACT.CONTRACTID),id,QueryConstants.EQUAL));
        }
        return sq;
    }

    /**
     *
     * @param escalateToID
     * @return
     */
    private boolean checkForEscalateToID(Long escalateToID)
    {
        boolean result = false;
        try
        {
            DataObject escToNDo = DataAccessUtil.getInstance().get(ESCALATETON.TABLE, new Criteria(Column.getColumn(ESCALATETON.TABLE, ESCALATETON.ESCALATETOID), escalateToID, QueryConstants.EQUAL));
            if (!escToNDo.isEmpty() && escToNDo.containsTable(ESCALATETON.TABLE))
            {
                result = true;
            }
        }
        catch (Exception e)
        {
            logger.log(Level.FINE, " Exception occured while trying to check whether user have been defined for the given escalateToID : {0}", escalateToID);
            result = false;
        }
        return result;
    }

    /**
     *
     * @param request
     * @param fileNames
     * @return
     * @throws Exception
     */
    public String[] getAttachmentArray(HttpServletRequest request, String fileNames) throws Exception
    {
        Vector vec = new Vector();
        int i = fileNames.indexOf(",");//No I18N
        String module = "Notifications";//No I18N
        String mod = (String) request.getAttribute("notifymodule");
        if (mod != null && mod != "" && mod.equals("PONotifications"))
        {
            module = "PONotifications";//No I18N
        }
        if (i == -1)
        {
            vec.addElement(ServiceDeskUtil.getInstance().getServerHomeDir() + File.separator + "bin" + File.separator + "Attachments" + File.separator + module + File.separator + (ServiceDeskUtil.getInstance().getUserId()).toString() + File.separator + fileNames);
            String[] ss = (String[]) vec.toArray(new String[0]);
            return ss;
        }
        else
        {
            String str = fileNames.substring(0, i);
            vec.addElement(ServiceDeskUtil.getInstance().getServerHomeDir() + File.separator + "bin" + File.separator + "Attachments" + File.separator + module + File.separator + (ServiceDeskUtil.getInstance().getUserId()).toString() + File.separator + str);

            while (true)
            {
                int j = fileNames.indexOf(",", i + 1);//No I18N
                if (j == -1)
                {
                    String ss1 = fileNames.substring(i + 1, fileNames.length());
                    vec.addElement(ServiceDeskUtil.getInstance().getServerHomeDir() + File.separator + "bin" + File.separator + "Attachments" + File.separator + module + File.separator + (ServiceDeskUtil.getInstance().getUserId()).toString() + File.separator + ss1);
                    String[] ss = (String[]) vec.toArray(new String[0]);
                    return ss;
                }
                else
                {
                    String str11 = fileNames.substring(i + 1, j);
                    vec.addElement(ServiceDeskUtil.getInstance().getServerHomeDir() + File.separator + "bin" + File.separator + "Attachments" + File.separator + module + File.separator + (ServiceDeskUtil.getInstance().getUserId()).toString() + File.separator + str11);
                }
                i = j;
            }
        }
    }




    //Converting non-english characters to unicode
    private String unicode(String message) throws Exception {
        byte[] bytesData=message.getBytes("UTF-16BE");//NO I18N
        StringBuffer uniString = new StringBuffer(bytesData.length * 2);
        for (int i = 0; i < bytesData.length; i++) {
            String hexByteStr = Integer.toHexString(bytesData[i] & 0xff).toUpperCase();
            if (hexByteStr.length() == 1) {
                uniString.append("0");// No I18N
            }
            uniString.append(hexByteStr);
        }
        return uniString.toString();
    }

    /**
     *
     * @param toAddress
     * @param title
     * @param description
     * @return
     * @throws ServiceDeskException
     */
    public String sendSMSNotification(String module , Long moduleId,String toAddress,String title,String description, Long loggedInUserID) throws ServiceDeskException,Exception
    {
        AeSdpBridgeInterface sdpBridge = ((AeSdpBridgeInterface) Class.forName("com.adventnet.servicedesk.utils.AeSdpBridgeImpl").newInstance()); //No I18N
        String messageID = "";
        String is_uncode=null;
        HashMap hmp=sdpBridge.checkSmsConfigDetails();
        Double Credits;
        try
        {
            description = ServiceDeskUtil.getInstance().getHTMLStrippedValue(description);
            // description = description.replaceAll("&quot;","\\\"");//NO I18N
            description = description.replaceAll("&quot;","\\\"");//NO I18N
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

        if(sdpBridge.isSMSGatewayConfigured())
        {
            Long serviceID=sdpBridge.getServiceID((Long)hmp.get("actionId"));//NO I18N
            JSONObject service=sdpBridge.getServiceDetails(serviceID);
            String servicename=service.getString("name");

            if(hmp.get("unicode_type")!=null)
            {is_uncode =hmp.get("unicode_type").toString();}

            if(servicename.equals("Clickatell_Platform") ||servicename.equals("twilio") ){
                toAddress=toAddress.replaceAll("[()]","");
            }
            else
            {
                toAddress=toAddress.replaceAll("[()+_-]","");//Need to change it to API specific
            }
            String[] recipientlist=toAddress.split(",");
            String message="";

            String connector="";
            logger.log(Level.INFO,"Unicode is set to"+is_uncode);
            if(title.length()!=0){connector="\n";}
            message=title+connector+description;
            message=message.replaceAll("\t","   ");//NO I18N
            message=message.replaceAll("\r","");//No I18N
            message=message.replace("&amp;", "&");//No I18n

            if(is_uncode==null||is_uncode.equals("null") || (servicename.equals("Site24x7")||servicename.equals("Clickatell_Platform"))){
                message= WebClientUtil.getEscapedString(message);
            }
            else
            {

                //Converting non-english characters into unicode characters
                message=message.replaceAll("\\\\t"," ");//No I18N
                message=message.replaceAll("\\\\n","\n");//No I18N

                message=unicode(message);
            }
            String return_result=null;
            for (int i = 0; i < recipientlist.length; i++) {
            JSONObject fieldValues=new JSONObject();
            fieldValues.put("recipients", recipientlist[i]);
            fieldValues.put("message",message);


            //Executing Send SMS Action
            JSONObject sendSmsResults=sdpBridge.executeAction(new Long(hmp.get("actionId").toString()),fieldValues,module,moduleId, loggedInUserID);

            String moduleName;
            if(!module.equals("Send_SMS_API")){
                moduleName=new String(module+"_SMS_Notification");//NO I18N
            }
            else{
                moduleName=module;
            }
            ServiceDeskUtil.getInstance().populateSystemLog("Admin", moduleName,"Response obtained while sending sms: "+sendSmsResults.get("data"), "", ServiceDeskUtil.getInstance().INFO, ServiceDeskUtil.getInstance().UPDATE); // No I18N

            //Getting action id for GetCredits and executing the action
            ArrayList actionIDs=sdpBridge.getAllActionIDsInAService(serviceID);
            JSONObject creditResults=null;
            Long creditActionID=null;
            if(actionIDs.size()>1){
                creditActionID=(Long)actionIDs.get(1);
                creditResults=sdpBridge.executeAction(creditActionID, fieldValues, module, moduleId, loggedInUserID);
            }
            Boolean is_sms_sent=false;
            String availableCredits="";
            String result="";
            JSONObject params=null;
            JSONObject sms_response_format=null;
            String strjson;
            try{
                if(creditActionID!=null){
                    params=sdpBridge.getServiceActionReqConfigDetails(creditActionID);
                    if(params.get("response_format")!=null){
                        strjson=params.getJSONObject("response_format").getString("response").replace("\\","");
                        JSONObject credits_response_format=new JSONObject(strjson);
                        //Checking Sms sent Successfully
                        if(credits_response_format.getString("format").equals("json")){
                            result=findJSONResponseByPath(creditResults.getJSONObject("data"),credits_response_format.getString("field"));
                        }
                        else{
                            String[] temp=creditResults.getString("data").split("\\"+credits_response_format.getString("format"));
                            result=temp[Integer.parseInt(credits_response_format.getString("field"))];
                        }
                        if(!result.equals("")){
                            availableCredits=result;
                        }
                        Credits=Double.parseDouble(availableCredits);
                        notifyOnLessCredits(Credits,servicename);
                        logger.log(Level.INFO,"Get Credits Response: "+creditResults.get("data"));
                    }
                }
                result="";
                params=sdpBridge.getServiceActionReqConfigDetails((Long)actionIDs.get(0));
                if(params.get("response_format")!=null){
                    strjson=params.getJSONObject("response_format").getString("response").replace("\\","");
                    sms_response_format=new JSONObject(strjson);
                }

                if(sms_response_format!=null){
                    if(sms_response_format.getString("format").equals("json")){
                        Pattern p = Pattern.compile("\\[(.*?)\\]");
                        Matcher m = p.matcher(sms_response_format.getString("field"));
                        int value = -1;
                        while (m.find()) {
                            if(m.group(1).toString().equals("N")){
                                value = 1;
                            }
                        }
                        if(value==-1)
                        {
                            result=findJSONResponseByPath(sendSmsResults.getJSONObject("data"),sms_response_format.getString("field"));
                        }
                        else
                        {
                            result=findJSONResponseByPath(sendSmsResults.getJSONObject("data"),sms_response_format.getString("field"),sms_response_format.getString("value"));
                            if(sms_response_format.has("error_field"))
                            {
                                sms_response_format.put("error_field",sms_response_format.getString("error_field").replaceAll("\\[N\\]","["+result+"]"));
                            }
                        }
                    }
                    else if(sms_response_format.getString("format").equals("contains"))
                    {
                        is_sms_sent=sendSmsResults.getString("data").contains(sms_response_format.getString("value"));
                    }
                    else{
                        String[] temp=sendSmsResults.getString("data").split("\\"+sms_response_format.getString("format"));
                        result=temp[Integer.parseInt(sms_response_format.getString("field"))];
                    }
                    if(result.equals(sms_response_format.getString("value"))||is_sms_sent){
                        is_sms_sent=true;
                    }
                    else
                    {
                        is_sms_sent=false;
                        if(sms_response_format.has("error_field") && sms_response_format.getString("format").equals("json"))
                        {
                            result=findJSONResponseByPath(sendSmsResults.getJSONObject("data"),sms_response_format.getString("error_field"));
                        }
                        else if(sms_response_format.getString("format").equals("contains"))
                        {
                            //result=sendSmsResults.getJSONObject("data").toString();
                            result = ""; //No I18N
                        }
                        else
                        {
                            String[] temp=sendSmsResults.getString("data").split("\\"+sms_response_format.getString("format"));
                            result=temp[Integer.parseInt(sms_response_format.getString("error_field"))];
                        }
                        if(result.equals(""))
                        {
                            result="admin.sms_conf.sendsms.errorsmsg"; //No I18N
                        }
                    }

                }
            }
            catch(Exception e){
                e.printStackTrace();
                is_sms_sent=false;
            }
            logger.log(Level.INFO,"Send SMS Response: "+sendSmsResults.get("data"));



            if(is_sms_sent==true){
                if(module.equals("Send_SMS_API")){
                    sendSmsResults.put("is_sms_sent",true);
                }
                sendSmsResults.put("credits", availableCredits);
                sendSmsResults.put("description", "admin.sms_conf.sendsms.successmsg");
                return_result=sendSmsResults.toString();
            }
            else if((is_sms_sent==false)){
                if(module.equals("Send_SMS_API")){
                    JSONObject sendsmsObj=new JSONObject();
                    sendsmsObj.put("is_sms_sent", is_sms_sent);
                    sendSmsResults.put("description",result);
                    sendSmsResults.put("credits",availableCredits);
                    sendsmsObj.put("response",sendSmsResults.toString());
                    return_result=sendsmsObj.toString();
                }
                else{return_result= null;}
            }
            }
            return  return_result;
        }
        else if(hmp.get("smsMail").toString().equals("true"))
        {
            String fromAddress = null;
            String fromName = null;
            String host = null;
            Long port = null;
            if (toAddress == null)
            {
                return null;
            }
            // Get system properties
            Properties props = System.getProperties();
            logger.log(Level.FINE, "Sys props : {0}", props);

            String smtpUserName;
            String smtpPassWord;
            boolean isAuthRequired = false;
            Criteria criteria = null;
            boolean tlsEnabled = false;
            String emailType = null;

            try
            {
                DataObject outgoingDO = MailUtilities.getInstance().getOutgoingMailServerDetails();
                Row outgoingRow = outgoingDO.getRow(OUTGOINGMAILSERVER.TABLE);
                host = (String) outgoingRow.get(OUTGOINGMAILSERVER.HOSTNAME);
                Long portId = (Long) outgoingRow.get(OUTGOINGMAILSERVER.PORTID);
                logger.log(Level.FINE, "host -----> {0} port id ---------> {1}", new Object[]{host, portId});
                if (portId != null)
                {
                    //SD-21920-SMTPS support for outgoing
                    DataObject portDO = MailUtilities.getInstance().getMailPortDetails();
                    Criteria criteria1 = new Criteria(Column.getColumn(MAILPORTDETAILS.TABLE, MAILPORTDETAILS.PORTID), portId, QueryConstants.EQUAL);
                    logger.log(Level.FINEST, "Port criteria : {0}", criteria1);
                    Row portRow = portDO.getRow(MAILPORTDETAILS.TABLE, criteria1);
                    port = (Long) portRow.get(MAILPORTDETAILS.PORT);
                    emailType = (String) portRow.get(MAILPORTDETAILS.EMAILTYPE);
                    tlsEnabled = (Boolean) portRow.get(MAILPORTDETAILS.TLSENABLED);
                    logger.log(Level.FINE, " emailType ---------> {0} tlsEnabled ---------> {1}", new Object[]{emailType, tlsEnabled});
                }
            }
            catch (Exception e)
            {
                ServiceDeskException sde = new ServiceDeskException("Exception while trying to trying to get the outgoing mail sever DNS Name/IP Address.", e);//No I18N
                sde.setErrorCode(ServiceDeskErrorCode.ER_FETCHING_DATA);
                throw sde;
            }

            try
            {
                if (fromAddress == null || fromAddress.equals(""))
                {
                    DataObject aliasesDO = MailUtilities.getInstance().getOutgoingMailAliases();
                    fromAddress = (String) aliasesDO.getFirstValue(OUTGOINGMAILALIASES.TABLE, OUTGOINGMAILALIASES.FROMEMAILID);
                    fromName = (String) aliasesDO.getFirstValue(OUTGOINGMAILALIASES.TABLE, OUTGOINGMAILALIASES.SENDERNAME);
                }
            }
            catch (Exception e)
            {
                ServiceDeskException sde = new ServiceDeskException("Problem occured while fetching the from address for the notification to be sent.", e);//No I18N
                sde.setErrorCode(ServiceDeskErrorCode.ER_FETCHING_DATA);
                throw sde;
            }

            if (host == null || host.equals(""))
            {
                ServiceDeskException sde = new ServiceDeskException("Outgoing mail server name is not configured properly. It could be null or empty.");//No I18N
                sde.setErrorCode(ServiceDeskErrorCode.ER_OUTGOING_MAILSERVER_NAME);
                throw sde;
            }
            if (fromAddress == null || fromAddress.equals(""))
            {
                ServiceDeskException sde = new ServiceDeskException("Problem occured while fetching the from address for the notification to be sent.");//No I18N
                sde.setErrorCode(ServiceDeskErrorCode.ER_GETTING_FROM_ADDRESS);
                throw sde;
            }
            //SD-21920-SMTPS support for outgoing
            props.put("mail.host", host);//No I18N
            props.put("mail.smtp.host", host);//No I18N

            if (port != null)
            {
                props.put("mail.smtp.port", port.toString());//No I18N
            }
            if (tlsEnabled)
            {
                props.put("mail.smtp.starttls.enable", "true"); //No I18N
            }
            if (emailType != null && "smtps".equals(emailType))
            {
                props.setProperty("mail.smtp.socketFactory.class", "javax.net.ssl.SSLSocketFactory");//No I18N
                props.setProperty("mail.smtp.socketFactory.port", port.toString());//No I18N
                props.setProperty("mail.smtp.socketFactory.fallback", "false");//No I18N
            }

            // Get session
            Session session;
            try
            {
                logger.log(Level.INFO,"Going to check any additional property for mail sending in MailProperties table");
                MailUtilities.getInstance().checkAndAddMailProperties(emailType, props);
                SMTPAuthenticator authenticator = MailUtilities.getInstance().getSMTPAuthenticator(props);
                session = Session.getInstance(props, authenticator);
                session.setDebug(false);
            }
            catch (Exception e)
            {
                ServiceDeskException sde = new ServiceDeskException("Exception while trying to trying to get the SMTP Authenticator info.", e);//No I18N
                sde.setErrorCode(ServiceDeskErrorCode.ER_FETCHING_DATA);
                throw sde;
            }

            // Define message
            MimeMessage message = new MimeMessage(session);
            InternetAddress ia = null;
            try
            {
                ia = new InternetAddress(fromAddress);
                //To set the personal name..
                if (!(fromName == null || fromName.equals("")))
                {
                    ia.setPersonal(fromName, "UTF-8");//No I18N
                }
            }
            catch (javax.mail.internet.AddressException ae)
            {
                ServiceDeskException sde = new ServiceDeskException("Wrongly formatted from address. Check for correct format.", ae);//No I18N
                sde.setErrorCode(ServiceDeskErrorCode.ER_WRONGLY_FORMATTED_ADDRESS);
                throw sde;
            }
            catch (UnsupportedEncodingException ue)
            {
                ServiceDeskException sde = new ServiceDeskException("Unsupported Encoding of personal name. Check for correct format.", ue);//No I18N
                //sde.setErrorCode(ServiceDeskErrorCode.ER_WRONGLY_FORMATTED_ADDRESS);
                throw sde;
            }

            try
            {
                if (ia != null)
                {
                    message.setFrom(ia);
                    //message.addRecipients(Message.RecipientType.TO,toAddress);
                    if (toAddress != null)
                    {
                        InternetAddress[] tos = InternetAddress.parse(toAddress);
                        int tolen = tos.length;
                        for (int loop = 0; loop < tolen; loop++)
                        {
                            InternetAddress too = tos[loop];
                            too.setPersonal(too.getPersonal(), "UTF-8");//No I18N
                        }
                        message.addRecipients(Message.RecipientType.TO, tos);
                    }
                    message.setSubject(title + " ", "UTF-8");//No I18N

                    Date currentDate = new Date();
                    message.setSentDate(currentDate);
                    message.setContent(description, "text/plain;charset=\"UTF-8\"");//No I18N
                    Transport.send(message);
                    messageID = message.getMessageID();
                    logger.log(Level.INFO, " message {0}", messageID);
                }
                else
                {
                    ServiceDeskException sde = new ServiceDeskException("Wrongly formatted from address. Check for correct format.");//No I18N
                    sde.setErrorCode(ServiceDeskErrorCode.ER_WRONGLY_FORMATTED_ADDRESS);
                    throw sde;
                }
            }
            catch (javax.mail.MessagingException me)
            {
                me.printStackTrace();
                ServiceDeskException sde = new ServiceDeskException("Mail sending failed.", me);//No I18N
                sde.setErrorCode(ServiceDeskErrorCode.ER_MAIL_SENDING_FAILED);
                throw sde;
            }
            catch (java.io.UnsupportedEncodingException e)
            {
                e.printStackTrace();
                ServiceDeskException sde = new ServiceDeskException("Mail sending failed due to UnsupportedEncodingException.", e);//No I18N
                sde.setErrorCode(ServiceDeskErrorCode.ER_MAIL_SENDING_FAILED);
                throw sde;
            }

        }

        return messageID;
    }

    private String findJSONResponseByPath(JSONObject jObj, String k,String... val){
        String[] path = k.split("\\.");
        JSONObject temp = jObj;
        try {
            for (int i = 0; i < path.length; i++) {
                if (i == path.length - 1) {
                    if (temp.has(path[i])) {
                        return temp.get(path[i]).toString();
                    }
                }
                else if (path[i].endsWith("]")) {
                    Pattern p = Pattern.compile("\\[(.*?)\\]");
                    Matcher m = p.matcher(path[i]);
                    int value = -1;
                    while (m.find()) {
                        if(!m.group(1).toString().equals("N")){
                            value = Integer.parseInt(m.group(1));
                        }
                    }
                    String[] te = path[i].split("\\[");
                    if(value!=-1)
                    {
                        if (temp.get(te[0]) instanceof JSONArray) {
                            JSONArray jar = (JSONArray) temp.get(te[0]);
                            temp = jar.getJSONObject(value);
                        }
                    }
                    else
                    {
                        JSONArray jar = (JSONArray) temp.get(te[0]);
                        String remainpath="";
                        for(;i<path.length-1;i++){
                            remainpath=path[i+1]+".";
                        }
                        if(val.length>0)
                        {
                            String svalue="";
                            for (int t = 0; t < jar.length(); t++) {
                                JSONObject j = jar.getJSONObject(t);
                                String result=findJSONResponseByPath(j, remainpath);
                                svalue=val[0].toString();
                                if(!result.equals(svalue))
                                {
                                    return ""+t;
                                }

                            }
                            return svalue;
                        }

                    }

                }
                else {
                    temp = temp.getJSONObject(path[i]);
                }
            }
        } catch (JSONException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return "";
        }
        return "";
    }

    //If credits available is less than 10, send mail notification to the users mentioned in the notification rules
    public void notifyOnLessCredits(Double sms_credits,String servicename ){
        if(sms_credits<10){
            Hashtable<Long,String> userlist=new Hashtable<Long,String>();
            try{
                String notifyenable=GlobalConfigUtil.getInstance().getGlobalConfigValue("EmailSystemError","SystemErrorNotification");//NO I18N
                if(notifyenable != null && notifyenable.equals("on"))
                {
                    Long escToID =new Long(GlobalConfigUtil.getInstance().getGlobalConfigValue("ESCALATETOID","SystemErrorNotification"));//NO I18N
                    userlist = NotificationFactory.getInstance().getUsersToNofity(escToID,"E-Mail");//NO I18N
                    for(Entry<Long, String> m:userlist.entrySet()){
                        String emailID=m.getValue();
                        String title="Warning :  SMS Notification Credits -"+sms_credits;//NO I18N
                        String desc=servicename + "Credits is "+ sms_credits+ ". Please Buy "+servicename+" Credits as soon as possible";//NO I18N
                        NotificationFactory.getInstance().sendMailNotification(emailID,title,desc,"","text/html",null,ServiceDeskUtil.getInstance().getUserId());//NO I18N
                    }
                }
            }
            catch(Exception e){
                e.printStackTrace();
            }
        }
    }


    /**
     * Notification methods taken from SDP - NotificationUtil class. That class
     * now uses these methods internally. Moved here for using cache in Asset
     * source also
     * @throws Exception
     */
    public void updateNotificationCache() throws Exception
    {
        String cacheAvailable = (String) CacheUtil.getFromCache(CacheUtil.NOTIFICATION_CONTENT_CACHE);
        if (cacheAvailable == null)
        {
            synchronized (this)
            {
                if (CacheUtil.getFromCache(CacheUtil.NOTIFICATION_CONTENT_CACHE) == null)
                {
                    notificationDetails = new HashMap<String, DataObject>();
                    notificationStatus = new HashMap<String, Boolean>();

                    //cwf start
                    notificationIDVsDetails = new HashMap<Long, DataObject>();
                    //cwf end

                    ArrayList list = new ArrayList(3);
                    list.add(NOTIFICATIONCONTENT.TABLE);
                    list.add(AAAUSER.TABLE);
                    list.add(ESCALATETON.TABLE);

                    SelectQueryImpl sql = new SelectQueryImpl(Table.getTable(NOTIFICATIONCONTENT.TABLE));
                    sql.addSelectColumn(Column.getColumn(NOTIFICATIONCONTENT.TABLE, "*"));
                    //SD-38621: To exclude Business rule notification templates other than default template in cache.
                    Criteria BRcrit = new Criteria(Column.getColumn(NOTIFICATIONCONTENT.TABLE, NOTIFICATIONCONTENT.NOTIFICATIONTYPE), "BusinessRule_EMail_*", QueryConstants.NOT_LIKE);
                    Criteria BRcrit1 = new Criteria(Column.getColumn(NOTIFICATIONCONTENT.TABLE, NOTIFICATIONCONTENT.NOTIFICATIONTYPE), "BusinessRule_SMS_*", QueryConstants.NOT_LIKE);
                    BRcrit = BRcrit.and(BRcrit1);
                    sql.setCriteria(BRcrit);
                    sql.addSortColumn(new SortColumn(Column.getColumn(NOTIFICATIONCONTENT.TABLE, NOTIFICATIONCONTENT.NOTIFICATIONCONTENTID), false));
                    DataObject notificationDO = DataAccessUtil.getInstance().get(sql);
                    Iterator iter = notificationDO.getRows(NOTIFICATIONCONTENT.TABLE);

                    while (iter.hasNext())
                    {
                        Row curRow = (Row) iter.next();
                        Boolean isEnabled = (Boolean) curRow.get(NOTIFICATIONCONTENT.ISENABLED);
                        Long escId = (Long) curRow.get(NOTIFICATIONCONTENT.ESCALATETOID);
                        String notName = (String) curRow.get(NOTIFICATIONCONTENT.NOTIFICATIONTYPE);
                        //cwf start
                        Long notID = (Long)curRow.get("NOTIFICATIONCONTENTID");
                        //cwf end
                        notificationStatus.put(notName, isEnabled);
                        DataObject daob = notificationDO.getDataObject(list, curRow);
                        if (escId != null)
                        {
                            SelectQueryImpl sqlImpl = new SelectQueryImpl(Table.getTable(AAAUSER.TABLE));
                            sqlImpl.addSelectColumn(Column.getColumn(AAAUSER.TABLE, "*"));
                            Join escJoin = new Join(AAAUSER.TABLE, ESCALATETON.TABLE, new String[]{AAAUSER.USER_ID}, new String[]{ESCALATETON.USERID}, Join.INNER_JOIN);
                            sqlImpl.addJoin(escJoin);
                            sqlImpl.addSelectColumn(Column.getColumn(ESCALATETON.TABLE, "*"));
                            Criteria crit = new Criteria(Column.getColumn(ESCALATETON.TABLE, ESCALATETON.ESCALATETOID), new Long(escId), QueryConstants.EQUAL);
                            sqlImpl.setCriteria(crit);
                            DataObject usersDO = DataAccessUtil.getInstance().get(sqlImpl);
                            daob.merge(usersDO);
                        }
                        logger.log(Level.FINEST, "NotificationContent to be cached daob:{0}", daob);
                        notificationDetails.put(notName, daob);
                        //cwf start
                        notificationIDVsDetails.put(notID,daob);
                        //cwf end
                    }
                    CacheUtil.addToCache(CacheUtil.NOTIFICATION_CONTENT_CACHE, "true", list); // No I18N
                }
            }
        }
    }

    /**
     *
     * @param notificationName
     * @return
     * @throws Exception
     */
    public boolean isNotificationEnabled(String notificationName) throws Exception
    {
        updateNotificationCache();
        Boolean result = (Boolean) notificationStatus.get(notificationName);
        return result.booleanValue();
    }

    /**
     * Method to set the status notification
     * @param notificationType  Notification type
     * @param isEnabled     Enable/Disable E-Mail notification
     */
    public void setNotificationStatus(String notificationType, Boolean isEnabled) throws Exception
    {
        UpdateQuery update = new UpdateQueryImpl(NOTIFICATIONCONTENT.TABLE);

        update.setUpdateColumn(NOTIFICATIONCONTENT.ISENABLED, isEnabled);

        update.setCriteria(new Criteria(Column.getColumn(NOTIFICATIONCONTENT.TABLE, NOTIFICATIONCONTENT.NOTIFICATIONTYPE), notificationType, QueryConstants.EQUAL));

        ResourcesUtil.getInstance().update(update);
    }

    /**
     *
     * @param notificationName
     * @return
     * @throws Exception
     */
    public DataObject getNotificationDetails(String notificationName) throws Exception
    {
        updateNotificationCache();
        //SD-38621: To exclude Business rule notification templates other than default template in cache. (i.e) below we are getting it from DB.
        if (!notificationDetails.containsKey(notificationName) && (notificationName.contains("BusinessRule_EMail_") || notificationName.contains("BusinessRule_SMS_")))
        {
            SelectQueryImpl sql = new SelectQueryImpl(Table.getTable(NOTIFICATIONCONTENT.TABLE));
            sql.addSelectColumn(Column.getColumn(NOTIFICATIONCONTENT.TABLE, "*"));
            Criteria Dynacrit = new Criteria(Column.getColumn(NOTIFICATIONCONTENT.TABLE, NOTIFICATIONCONTENT.NOTIFICATIONTYPE), notificationName, QueryConstants.EQUAL);
            sql.setCriteria(Dynacrit);
            DataObject notificationDO = DataAccessUtil.getInstance().get(sql);
            Long escId = (Long) notificationDO.getFirstValue(NOTIFICATIONCONTENT.TABLE, NOTIFICATIONCONTENT.ESCALATETOID);
            logger.log(Level.FINEST, "NotificationDO for Businessrule from DB:{0}", notificationDO);

            if (escId != null)
            {
                SelectQueryImpl sqlImpl = new SelectQueryImpl(Table.getTable(AAAUSER.TABLE));
                sqlImpl.addSelectColumn(Column.getColumn(AAAUSER.TABLE, "*"));
                Join escJoin = new Join(AAAUSER.TABLE, ESCALATETON.TABLE, new String[]{AAAUSER.USER_ID}, new String[]{ESCALATETON.USERID}, Join.INNER_JOIN);
                sqlImpl.addJoin(escJoin);
                Criteria crit = new Criteria(Column.getColumn(ESCALATETON.TABLE, ESCALATETON.ESCALATETOID), new Long(escId), QueryConstants.EQUAL);
                sqlImpl.setCriteria(crit);
                DataObject usersDO = DataAccessUtil.getInstance().get(sqlImpl);
                notificationDO.merge(usersDO);
                logger.log(Level.FINEST, "NotificationDO for Businessrule from DB after userDO merge:{0}", notificationDO);
            }

            if (notificationDO.isEmpty())
            {
                return null;
            }
            else
            {
                return notificationDO;
            }
        }
        else
        {
            return (DataObject) notificationDetails.get(notificationName);
        }
    }

    /**
     *
     * @param notifType
     * @param column
     * @return
     * @throws Exception
     */
    public String getNotificationConfigEntry(String notifType, String column) throws Exception
    {
        String returnStr = null;
        DataObject dob = getNotificationDetails(notifType);
        if (!dob.isEmpty())
        {
            returnStr = (String) dob.getFirstValue(NOTIFICATIONCONTENT.TABLE, column);
        }
        return returnStr;
    }

    /**
     * Fetch the corresponding entry from NotificationContent table..
     * @param notifType
     * @return
     * @throws Exception
     */
    public String getSubjectConfiguration(String notifType) throws Exception
    {
        return getNotificationConfigEntry(notifType, "SUBJECT");//No I18N
    }

    /**
     * Fetch the corresponding entry from NotificationContent table..
     * @param notifType
     * @return
     * @throws Exception
     */
    public String getContentConfiguration(String notifType) throws Exception
    {
        return getNotificationConfigEntry(notifType, "CONTENT");//No I18N
    }

    public String[] getNotificationContent(String templateName, DataObject dObj) throws Exception
    {
        String subject = null;
        String description = null;
        SelectQuery sql = new SelectQueryImpl(Table.getTable(NOTIFICATIONCONTENT.TABLE));
        Join join = new Join(NOTIFICATIONCONTENT.TABLE, NOTIFICATIONTEMPLATE.TABLE, new String[]{NOTIFICATIONCONTENT.NOTIFICATIONCONTENTID}, new String[]{NOTIFICATIONTEMPLATE.NOTIFICATIONCONTENTID}, Join.LEFT_JOIN);
        sql.addJoin(join);

        sql.addSelectColumn(Column.getColumn(NOTIFICATIONCONTENT.TABLE, "*"));//No I18N
        sql.addSelectColumn(Column.getColumn(NOTIFICATIONTEMPLATE.TABLE, "*"));//No I18N

        Criteria cri = new Criteria(Column.getColumn(NOTIFICATIONCONTENT.TABLE, NOTIFICATIONCONTENT.NOTIFICATIONTYPE), templateName, QueryConstants.EQUAL, false);
        cri = cri.and(Column.getColumn(NOTIFICATIONCONTENT.TABLE, NOTIFICATIONCONTENT.ISENABLED), Boolean.TRUE, QueryConstants.EQUAL);
        sql.setCriteria(cri);

        DataObject availableTemplates = DataAccessUtil.getInstance().get(sql);

        if (availableTemplates.containsTable(NOTIFICATIONTEMPLATE.TABLE))
        {
            SortedMap<String, String> templateVariables = new java.util.TreeMap<String, String>(Collections.reverseOrder());
            Row row = null;
            for (Iterator it = availableTemplates.getRows(NOTIFICATIONTEMPLATE.TABLE); it.hasNext();)
            {
                row = (Row) it.next();
                templateVariables.put((String) row.get(NOTIFICATIONTEMPLATE.VARIABLENAME), row.get(NOTIFICATIONTEMPLATE.TABLENAME) + ":" + row.get(NOTIFICATIONTEMPLATE.COLUMNNAME) + ":" + row.get(NOTIFICATIONTEMPLATE.ISDATECOLUMN));//No I18N
            }

            String additionalTableName = null;

            if ("Contract_Notification".equals(templateName))
            {
                additionalTableName = CONTRACT_FIELDS.TABLE;
            }
            else if ("Purchase_Notification".equals(templateName) || "POPendingApprovalNotification".equals(templateName) || "POApprovedNotification".equals(templateName) || "PORejectedNotification".equals(templateName) || "POCanceledNotification".equals(templateName) || "PORejectedNotificationForSRT".equals(templateName) || "POPartiallyReceivedNotificationForSRT".equals(templateName) || "POReceivedNotificationForSRT".equals(templateName) || "POCanceledNotificationForSRT".equals(templateName))
            {
                additionalTableName = PURCHASEORDER_FIELDS.TABLE;

            }
            else if( "PROpenNotification".equals(templateName) || "PRPendingApprovalNotification".equals(templateName) || "PRApprovedNotification".equals(templateName) || "PRRejectedNotification".equals(templateName) || "PRCloseNotification".equals(templateName) || "PRCancelNotification".equals(templateName) || "PRReceivedNotification".equals(templateName) || "PRPartiallyReceivedNotification".equals(templateName) || "PROverdueNotification".equals(templateName) )
            {
                additionalTableName = PURCHASEREQUEST_FIELDS.TABLE;
            }

            if (additionalTableName != null)
            {
                DataObject dObject = DataAccessUtil.getInstance().get(COLUMNALIASES.TABLE, new Criteria(Column.getColumn(COLUMNALIASES.TABLE, COLUMNALIASES.TABLENAME), additionalTableName, QueryConstants.EQUAL, false));
                if( "PurchaseRequest_Fields".equals(additionalTableName) )
                {
                    additionalTableName = "udf_fields";//No I18N
                }
                if (dObject.containsTable(COLUMNALIASES.TABLE))
                {
                    Row tempRow = null;
                    String columnName = null;
                    String dollarVariable = "$";//No I18N
                    for (Iterator ad = dObject.getRows(COLUMNALIASES.TABLE); ad.hasNext();)
                    {
                        tempRow = (Row) ad.next();
                        columnName = (String) tempRow.get(COLUMNALIASES.COLUMNNAME);
                        if (columnName.indexOf("UDF_DATE") < 0)
                        {
                            templateVariables.put(dollarVariable + columnName, additionalTableName + ":" + columnName + ":false");//No I18N
                        }
                        else
                        {
                            templateVariables.put(dollarVariable + columnName, additionalTableName + ":" + columnName + ":true");//No I18N
                        }
                    }
                }
            }

            if (availableTemplates.containsTable(NOTIFICATIONCONTENT.TABLE))
            {
                subject = (String) availableTemplates.getFirstValue(NOTIFICATIONCONTENT.TABLE, NOTIFICATIONCONTENT.SUBJECT);
                description = (String) availableTemplates.getFirstValue(NOTIFICATIONCONTENT.TABLE, NOTIFICATIONCONTENT.CONTENT);
                for (Iterator it = templateVariables.keySet().iterator(); it.hasNext();)
                {
                    String templateVariable = (String) it.next();
                    logger.log(Level.INFO, "TEMPLATE VARIABLE : {0}", templateVariable);
                    String tableDetails[] = ((String) templateVariables.get(templateVariable)).split(":");//No I18N
                    String tableName = tableDetails[0];
                    String columnName = tableDetails[1];
                    String isDateColumn = tableDetails[2];

                    if (dObj.containsTable(tableName))
                    {
                        Object templateValue = null;
                        if (dObj.size(tableName) == 1)
                        {
                            templateValue = dObj.getFirstValue(tableName, columnName);
                        }
                        else
                        {
                            Row tempRow = null;
                            for (Iterator its = dObj.getRows(tableName); its.hasNext();)
                            {
                                tempRow = (Row) its.next();
                                if (templateValue != null)
                                {
                                    templateValue = templateValue + "<br>" + tempRow.get(columnName);//no i18n
                                }
                                else
                                {
                                    templateValue = tempRow.get(columnName);
                                }
                            }
                        }

                        if (templateValue == null)
                        {
                            templateValue = "-";//no i18n
                        }

                        templateVariable = "\\$" + templateVariable.substring(1, templateVariable.length());//no i18n

                        if ("true".equals(isDateColumn) && !"-".equals(templateValue))
                        {
                            Long dateLongValue = new Long(templateValue.toString());
                            if (dateLongValue.longValue() > 0)
                            {
                                templateValue = ServiceDeskUtil.getDateAsString(ServiceDeskUtil.getInstance().getUserId(), (Long) templateValue, "N/A");//No I18N
                            }
                            else
                            {
                                templateValue = "-";//No I18N
                            }
                        }
                        else if( templateVariable.indexOf("RequestedItems") >= 0 )
                        {
                            templateValue = getRequestedItemsDetail(dObj);
                        }
                        logger.log(Level.INFO, "TEMPLATE VALUE = {0}", templateValue);
                        try
                        {
                            subject = subject.replaceAll(templateVariable, templateValue.toString());
                            description = description.replaceAll(templateVariable, templateValue.toString());
                        }
                        catch (Exception e)
                        {
                            e.printStackTrace();
                        }
                    }
                    else
                    {
                        logger.log(Level.INFO, "TEMPLATE VARIABLE VALUE NOT FOUND !!!");
                        try
                        {
                            templateVariable = "\\$" + templateVariable.substring(1, templateVariable.length());//no i18n
                            subject = subject.replaceAll(templateVariable, "");//No I18N
                            description = description.replaceAll(templateVariable, "");//No I18N
                        }
                        catch (Exception e)
                        {
                            e.printStackTrace();
                        }
                    }
                }
            }
        }
        if(subject != null && description != null)
        {
            String[] notificationContent = {subject,description};
            return notificationContent;
        }

        return null;

    }

    private String getRequestedItemsDetail( DataObject dObj ) throws Exception
    {
        StringBuffer buffer = new StringBuffer();

        if( dObj.containsTable("requested_items") )
        {
            buffer.append("<table style='background-color: #E8E8E8;' cellspacing='1' width='100%'><tbody><tr style='height:30px;'><th width='25%'><nobr>Item Name</nobr></th><th width='30%'><nobr>Description</nobr></th><th align='center' width='10%'><nobr>Quantity</nobr></th><th align='center' width='10%'><nobr>Received</nobr></th><th align='right' width='15%'><nobr>Estimated cost&nbsp;</nobr></th><th align='right' width='10%'><nobr>Total&nbsp;</nobr></th></tr>");//NO I18N

            Row rowObj = null;

            for( Iterator it = dObj.getRows("requested_items"); it.hasNext(); )
            {
                rowObj = (Row) it.next();

                buffer.append("<tr style='padding-left: 3px;height: 32px;background-color: #FFF;'>");//NO I18N
                buffer.append("<td align='center'>" + XSSEncoder.getInstance().encodeHTML((String)rowObj.get("ITEMNAME")) + "</td>");
                buffer.append("<td align='center'>" + (rowObj.get("DESCRIPTION") == null ? "-" : XSSEncoder.getInstance().encodeHTML((String)rowObj.get("DESCRIPTION"))) + "</td>");//NO I18N
                buffer.append("<td align='center'>" + rowObj.get("QUANTITY") + "</td>");//NO I18N
                buffer.append("<td align='center'>" + rowObj.get("RECEIVED") + "</td>");//NO I18N
                buffer.append("<td align='right'>" + rowObj.get("ESTIMATED_COST") + "</td>");//NO I18N
                buffer.append("<td align='right'>" + ((Double)rowObj.get("QUANTITY") * (Double)rowObj.get("ESTIMATED_COST")) + "</td></tr>");//NO I18N
            }
            buffer.append("</table>");//NO I18N
        }
        return buffer.toString();
    }
    /**
     * Method used to update the notification content on notification content table
     * @param notifType
     * @param content
     * @throws Exception
     */
    public void updateNotificationContent(String notifType, String subject,String content) throws Exception {
        DataObject notifContEditDO = getNotificationDetails(notifType);
        Row notifContRow = notifContEditDO.getRow(NOTIFICATIONCONTENT.TABLE);
        notifContRow.set(NOTIFICATIONCONTENT.SUBJECT, subject);
        notifContRow.set(NOTIFICATIONCONTENT.CONTENT, content);
        notifContEditDO.updateRow(notifContRow);
        ResourcesUtil.getInstance().update(notifContEditDO);

    }

    //CWF START
    public String getNotificationConfigEntry(Long notifId, String column) throws Exception
    {
        String returnStr = null;
        DataObject dob = getNotificationDetails(notifId);
        if(!dob.isEmpty())
        {
            returnStr = (String) dob.getFirstValue(NOTIFICATIONCONTENT.TABLE, column);
        }
        return returnStr;
    }
    public DataObject getNotificationDetails(Long notificationID) throws Exception
    {
        updateNotificationCache();
        return (DataObject) notificationIDVsDetails.get(notificationID);
    }

    public void moveNotificationDescriptionAsAttachment(String desc, DataObject daob)
    {
        try
        {
            logger.log(Level.FINE, "inside adding notification Description As Attachment");
            desc = StringUtil.getInstance().getCleanHTML(desc);
            Integer attLength = desc.length();
            String attModule = "Notifications";//NO I18N
            Long attCreator = ((Long) DBUtilities.getInstance().getResultObject(AAAUSER.TABLE,new Criteria(Column.getColumn(AAAUSER.TABLE,AAAUSER.FIRST_NAME),"System",QueryConstants.LIKE),AAAUSER.USER_ID));//No I18N
            Row notifyRow = daob.getRow(NOTIFICATION.TABLE);
            logger.log(Level.FINE, "inside adding Notification Description As Attachment and workorderRow is " + notifyRow);
            Long attModID = (Long) notifyRow.get(NOTIFICATION.NOTIFICATIONID);
            String date = new java.text.SimpleDateFormat("MM_dd_yyyy_HH_mm_ss").format(new Date().getTime());//No I18N
            String fileName = "NOTIFICATION_DESCRIPTION_" + date + ".html";      //No I18N
            // create temp file to be loaded as attachment
            AttachmentUtil.getInstance().tempFileCreationForRequest(desc,fileName, attModule);
            DataObject obj = AttachmentUtil.getInstance().addAttachments(fileName, attLength.toString(), attModule, attCreator, attModID, System.currentTimeMillis(), desc,true);
            Row sdeskdetails= obj.getFirstRow(SDESKATTACHMENT.TABLE);
            Iterator tmpItr = daob.getRows(NOTIFICATIONTODESC.TABLE);
            if(tmpItr.hasNext())
            {
                Row tmpRow = (Row)tmpItr.next();
                tmpRow.set("ATTACHMENTID",sdeskdetails.get(SDESKATTACHMENT.ATTACHMENTID)); //No I18N
                daob.updateRow(tmpRow);
            }
            ResourcesUtil.getInstance().update(daob);
        } catch (Exception ex)
        {
            logger.log(Level.SEVERE, null, ex);
        }
    }

    //GDPR changes START
        /*public String getEmailListAsString(ArrayList emailList, boolean toEncode){
            StringBuilder emailIds = null;
            if (emailList != null && emailList.size() > 0) {
                for (int i = 0; i < emailList.size(); i++) {
                    String email = (String) emailList.get(i);
                    if(toEncode){
                        email = XSSEncoder.getInstance().encodeHTML(email);
                    }
                    if (emailIds == null) {
                        emailIds = new StringBuilder();
                        emailIds.append(email);
                    } else {
                        emailIds.append(DEFAULTEMAILDELIMITER).append(" ").append(email);
                    }
                }
            }
            if (emailIds == null) {
                return null;
            }
            return emailIds.toString();
        }

        public boolean isEmailBlocked(String emailId) throws Exception {
            SelectQuery emailSq = new SelectQueryImpl(Table.getTable(EMAIL_RETENTION.TABLE));
            emailSq.addSelectColumn(Column.getColumn(EMAIL_RETENTION.TABLE, EMAIL_RETENTION.ID));
            Criteria emailCr = new Criteria(Column.getColumn(EMAIL_RETENTION.TABLE, EMAIL_RETENTION.EMAILID), emailId.toLowerCase(), QueryConstants.EQUAL);
            emailSq.setCriteria(emailCr);
            DataObject emailObj = DataAccessUtil.getInstance().get(emailSq);
            if (emailObj != null && !emailObj.isEmpty()) {
                return true;
            }
            return false;
        }

        public String getNonBlockedEmailIds(String emailIds){
            HashMap processedEmailMap = getEmailsClassifiedAsBlockedAndNonblocked(emailIds);
            if(processedEmailMap != null && processedEmailMap.containsKey(NONBLOCKED_EMAILS)){
                return getEmailListAsString((ArrayList) processedEmailMap.get(NONBLOCKED_EMAILS), false);
            }
            return null;
        }

        public HashMap getEmailsClassifiedAsBlockedAndNonblocked(String emailIds){
            return getEmailsClassifiedAsBlockedAndNonblocked(emailIds, DEFAULTEMAILDELIMITER);
        }

        public HashMap getEmailsClassifiedAsBlockedAndNonblocked(String emailIds, String delimiter){
            if(emailIds == null || "".equals(emailIds)){
                return null;
            }

            try {
                String[] emails = emailIds.split(delimiter);
                ArrayList<String> emailList = new ArrayList();
                for (String email : emails) {
                    emailList.add(email.trim().toLowerCase());
                }
                return getEmailsClassifiedAsBlockedAndNonblocked(emailList);
            }
            catch(Exception e){
                logger.log(Level.SEVERE, "Exception while trying to strip blocked emails : {0}", e.getMessage());
                e.printStackTrace();
                return null;
            }
        }

        private HashMap getEmailsClassifiedAsBlockedAndNonblocked(ArrayList emailList) throws Exception{
            if(emailList == null || emailList.size()==0){
                return null;
            }

            int fromIndex = 0;
            int endIndex = -1;
            int maxSize = 50;

            try {
                HashMap processedEmailMap = new HashMap();
                ArrayList clonedEmailList = (ArrayList) emailList.clone();
                ArrayList blockedEmailList = new ArrayList();

                SelectQuery emailSq = new SelectQueryImpl(Table.getTable(EMAIL_RETENTION.TABLE));
                emailSq.addSelectColumn(Column.getColumn(EMAIL_RETENTION.TABLE, EMAIL_RETENTION.ID));
                emailSq.addSelectColumn(Column.getColumn(EMAIL_RETENTION.TABLE, EMAIL_RETENTION.EMAILID));

                while (fromIndex < emailList.size()) {
                    endIndex = (fromIndex + maxSize - 1) < emailList.size() ? (fromIndex + maxSize) : emailList.size();
                    List subList = emailList.subList(fromIndex, endIndex);
                    fromIndex = fromIndex + maxSize;

                    emailSq.setCriteria(new Criteria(Column.getColumn(EMAIL_RETENTION.TABLE, EMAIL_RETENTION.EMAILID), (String[]) subList.toArray(new String[0]), QueryConstants.IN));
                    DataObject emailObj = DataAccessUtil.getInstance().get(emailSq);
                    if (emailObj != null) {
                        Iterator itr = emailObj.getRows(EMAIL_RETENTION.TABLE);
                        while (itr.hasNext()) {
                            Row curRow = (Row) itr.next();
                            String emailId = (String) curRow.get(EMAIL_RETENTION.EMAILID);
                            clonedEmailList.removeAll(Collections.singleton(emailId));
                            if(!blockedEmailList.contains(emailId)){
                                blockedEmailList.add(emailId);
                            }
                        }
                    }
                }
                logger.log(Level.INFO, "Final email list after stripping : {0}", clonedEmailList);

                processedEmailMap.put(NONBLOCKED_EMAILS, clonedEmailList);
                processedEmailMap.put(BLOCKED_EMAILS, blockedEmailList);
                return processedEmailMap;
            }
            catch(Exception e){
                logger.log(Level.SEVERE, "Exception while trying to strip blocked email list : {0}", e.getMessage());
                e.printStackTrace();
                return null;
            }
        }*/
    //GDPR changes END
     
        /*public String getNotificationContentType(Long notifID) throws Exception
        {
     
            ReadOnlyMap<Long,String> idVsName = (ReadOnlyMap)CacheUtil.getFromCache(CacheUtil.NOTIFICATIONCONTENT_IDVSTYPE);
            if(idVsName==null)
            {
                SelectQueryImpl sqlImpl = new SelectQueryImpl(Table.getTable("NotificationContent"));
                sqlImpl.addSelectColumn(Column.getColumn(NOTIFICATIONCONTENT.TABLE,NOTIFICATIONCONTENT.NOTIFICATIONCONTENTID));
                sqlImpl.addSelectColumn(Column.getColumn(NOTIFICATIONCONTENT.TABLE,NOTIFICATIONCONTENT.NOTIFICATIONTYPE));
                DataObject dataObj = DataAccessUtil.getInstance().get(sqlImpl);
                Iterator<Row> vals = dataObj.getRows(NOTIFICATIONCONTENT.TABLE);
                HashMap<Long,String> data = new HashMap<Long,String>();
                while(vals.hasNext())
                {
                    Row val = vals.next();
                    data.put((Long)val.get(NOTIFICATIONCONTENT.NOTIFICATIONCONTENTID),(String)val.get(NOTIFICATIONCONTENT.NOTIFICATIONTYPE));
                }
                idVsName = new ReadOnlyMap(data);
                ArrayList tableNames =new ArrayList();
                tableNames.add("NotficationContent");
                CacheUtil.addToCache(CacheUtil.NOTIFICATIONCONTENT_IDVSTYPE,idVsName,tableNames);
            }
            return idVsName.get(notifID);
        }*/
    //CWF END



    /**
     * This method should be used to populate the Notification table with data from the JSON object.
     * @param jsonObject - Mail JSON Object
     * @param notificationType - This should be CHGINCOMING, CHGREPLY or CHGFORWARD
     * @param module
     * @param moduleId
     * @return notificationID
     * @throws Exception
     * @throws DataAccessException
     * @throws RemoteException
     */
    public Long persistMailNotificationJSON(JSONObject jsonObject, String notificationType, String module, Long moduleId) throws Exception
    {
        String senderName = null, bccAddress = null, subject = null, htmlMailcontent = null, messageID = null;
        String fromAddress = null, toAddress = null, ccAddress = null, hasInLine = null, inlineImageReplacedContent = null;
        String attachmentName = null;
        String attachmentsize = null;
        HashMap<String, Integer> fileSizeMap = new HashMap<String, Integer>();

        org.json.JSONObject inlineMap = null, fileHash = null, modifiedMap = null, inlineIdNameMapper = null;
        org.json.JSONArray fileNamesVec = null;


        Long sentDate = null, notificationId = null;
        Long fromId = null, toId = null;
        try
        {
            senderName = jsonObject.getString("senders_name");
            fromAddress = jsonObject.getString("from_address");
            toAddress = jsonObject.getString("to_address");
            ccAddress = jsonObject.getString("cc_address");
            bccAddress = jsonObject.getString("bcc_address");
            subject = jsonObject.getString("subject");
            sentDate = jsonObject.getLong("sent_dateL");
            htmlMailcontent = jsonObject.getString("mail_content");
            hasInLine = jsonObject.getString("has_inline");
            fileHash =  (org.json.JSONObject) jsonObject.get("file_hash");//(Hashtable) - filenames and its size example: {1.java=java.io.BufferedInputStream@3d2973de, 2.java=java.io.BufferedInputStream@6c761330}
            fileNamesVec = (org.json.JSONArray) jsonObject.getJSONArray("filenames_list");
            messageID = jsonObject.getString("message_id");
            inlineImageReplacedContent = htmlMailcontent;

            if (ccAddress == "Not Provided")
            {
                ccAddress = null;
            }

            if (bccAddress == "Not Provided")
            {
                bccAddress = null;
            }

            try
            {
                fromId = ServiceDeskUtil.getInstance().getUserIdForMail(fromAddress);
            }
            catch (Exception e1)
            {
                e1.printStackTrace();
            }

                String filesWithInvalidExtension="";
                String filesWithInvalidContentType="";
                String emptyFiles="";
                String message="";

            if(!(fileNamesVec.length() == 0))
            {
                String storeLocation = null;
                StringBuilder attchSizeBuilder = new StringBuilder();
                StringBuilder attchNameBuilder = new StringBuilder();
                BufferedInputStream attchBufferedInputStream = null;
                for(int i = 0; i < fileNamesVec.length(); i++)
                {
                    String fileName = (String) fileNamesVec.get(i);
                    try
                    {
                        attchBufferedInputStream = (BufferedInputStream) fileHash.get(fileName);
                        fileName=StringUtil.getInstance().replaceSpecialCharactersInFileName(fileName);

                        int fileSize = AttachmentUtil.getInstance().storeAttachmentInTemp(fileName, fromId, attchBufferedInputStream, "Notifications"); //NO I18N
            			
                        //SD-35675: File Restriction
                        int validFile=AttachmentUtil.getInstance().validateFile(fileName,ResourcesUtil.getUserDir()+ File.separator +"Attachments" + File.separator + "Notifications" +File.separator + fromId.toString()); //NO I18N
                        if(validFile==1)
                        {
                            if(filesWithInvalidExtension=="")
                            {
                                filesWithInvalidExtension=fileName;
                            }
                            else
                            {
                                filesWithInvalidExtension=filesWithInvalidExtension+", "+fileName;
                            }
                        }
                        else if(validFile==2)
                        {
                            if(filesWithInvalidContentType=="")
                            {
                                filesWithInvalidContentType=fileName;
                            }
                            else
                            {
                                filesWithInvalidContentType=filesWithInvalidContentType+", "+fileName;
                            }
                        }
                        else if(validFile==3)
                        {
                            if(emptyFiles=="")
                            {
                                emptyFiles=fileName;
                            }
                            else
                            {
                                emptyFiles=emptyFiles+", "+fileName;
                            }
                        }
                        else
                        {
            			fileSizeMap.put(fileName, fileSize);
                        }
					}
                    catch(Exception ex)
                    {
                        ex.printStackTrace();
                    }
                    finally
                    {
                        if(attchBufferedInputStream != null)
                        {
                            try
                            {
                                attchBufferedInputStream.close();
                            }
                            catch(Exception ex)
                            {
                                ex.printStackTrace();
                            }
                        }
                    }
                }

                    if(!"".equals(filesWithInvalidExtension))
                    {
                        message=message+filesWithInvalidExtension+" - File(s) dropped as their extension is restricted. "+"\n";  //NO I18N
                    }
                    if(!"".equals(filesWithInvalidContentType))
                    {
                        message=message+filesWithInvalidContentType+" - File(s) dropped as their contenttype is restricted. "+"\n";  //NO I18N
                    }
                    if(!"".equals(emptyFiles))
                    {
                        message=message+emptyFiles+" - File(s) dropped as they are empty files. "+"\n";  // No I18N
                    }
                for(String fileName : fileSizeMap.keySet())
                {
                    Integer fileSize = fileSizeMap.get(fileName);
                    attchNameBuilder.append(fileName);
                    attchSizeBuilder.append(fileSize.toString());
                    attchNameBuilder.append(",");
                    attchSizeBuilder.append(",");
                }

                if(attchNameBuilder.length() > 1){attchNameBuilder.deleteCharAt(attchNameBuilder.length() - 1);}
                attachmentName = attchNameBuilder.toString();
                if(attchSizeBuilder.length() > 1){attchSizeBuilder.deleteCharAt(attchSizeBuilder.length() - 1);}
                attachmentsize = attchSizeBuilder.toString();

            }
            try
            {
                notificationId = populateNotificationWithModule(fromId, subject, htmlMailcontent, notificationType, messageID, toAddress, ccAddress, attachmentName, attachmentsize, module, moduleId);
                    if(!"".equals(message))
                    {
                        message=message+"Module: Change Conversation \n"+"Module id: "+notificationId;  //NO I18N
                        ServiceDeskUtil.getInstance().populateSystemLog("Mail Fetching","File Restriction", message, "",ServiceDeskUtil.INFO,0);
                    }
            }
            catch(Exception e)
            {
                if(!fileSizeMap.isEmpty())
                {
                    for(String fileName : fileSizeMap.keySet())
                    {
                        AttachmentUtil.getInstance().deleteFromTemp(fileName, "Notifications", fromId); // NO I18N
                    }
                }

                e.printStackTrace();
                throw e;
                //return null;
            }

            if (hasInLine.equalsIgnoreCase("Yes"))
            {
                inlineMap = (org.json.JSONObject) jsonObject.get("inline_map");//(LinkedHashMap) {0.png=java.io.BufferedInputStream@3be5ebf1, 1.jpg=java.io.BufferedInputStream@73e539ef}
                inlineIdNameMapper = (org.json.JSONObject) jsonObject.get("inline_id");//NO I18N
                if(!(inlineIdNameMapper.length() == 0))
                {
                    Iterator iter = inlineIdNameMapper.keys();
                    AttachmentUtil.getInstance().storeInlineImages(inlineMap, notificationId, "Notifications"); // NO I18N
                    while(iter.hasNext())
                    {
                        String key = (String) iter.next();
                        String inlineImageName = (String) inlineIdNameMapper.get(key);
                        inlineImageReplacedContent = inlineImageReplacedContent.replace(key, File.separator + "inlineimages" +File.separator +"Notifications"+ File.separator  + notificationId.toString()+ File.separator +  inlineImageName); //NO I18N
                    }
                    UpdateQueryImpl updateDescription = new UpdateQueryImpl(NOTIFICATIONTODESC.TABLE);
                    updateDescription.setUpdateColumn(NOTIFICATIONTODESC.DESCRIPTION, inlineImageReplacedContent);
                    updateDescription.setCriteria(new Criteria(new Column(NOTIFICATIONTODESC.TABLE, NOTIFICATIONTODESC.NOTIFICATIONID), notificationId, QueryConstants.EQUAL));
                    DataAccessUtil.getInstance().update(updateDescription);
                }
            }
        }
        catch (JSONException e1)
        {
            e1.printStackTrace();
            logger.log(Level.WARNING, "JSON not in required format.");
        }
        catch (RemoteException e)
        {
            e.printStackTrace();
        }
        catch (DataAccessException e)
        {
            e.printStackTrace();
            throw e;
        }
        catch (SQLException e)
        {
            e.printStackTrace();
            throw e;
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

        return notificationId;
    }

    /**
     * This method returns first 20 Conversation of a specific Module and ModuleId.
     * @param module
     * @param moduleId
     * @return first 20 Conversation of a specific Module and ModuleId.
     * @throws Exception
     */
    public DataObject getDefaultSetOfConversationDO(String module, Long moduleId, boolean needSystemNotification, boolean isAscending) throws Exception
    {
        return getGivenRangeOfConversationDO(module, moduleId, new Long(0), new Long(20), needSystemNotification, isAscending);
    }

    /**
     * This method fetches a single Notification
     * @param module
     * @param moduleId
     * @param notificationId
     * @return notification DataObject
     * @throws Exception
     */
    public DataObject getSingleNotificationnDO(String module, Long moduleId, Long notificationId) throws Exception
    {
        String moduleTable = null;
        String moduleIdColoumn = null;
        String moduleNotificationId = null;

        if (module.equalsIgnoreCase("Change") || module.equalsIgnoreCase("Changes"))
        {
            //moduleTable = NOTIFY_CHANGE.TABLE;
            moduleTable = "Notify_Change"; // NO I18N
            // moduleIdColoumn = NOTIFY_CHANGE.CHANGEID;
            moduleIdColoumn = "CHANGEID"; // NO I18N
            //moduleNotificationId = NOTIFY_CHANGE.NOTIFICATIONID;
            moduleNotificationId = "NOTIFICATIONID"; // NO I18N
        }
        //TODO: To refer Request team to use this method..
        if (module.equalsIgnoreCase("Request") || module.equalsIgnoreCase("Requests"))
        {
            //moduleTable = NOTIFY_WORKORDER.TABLE;
            moduleTable = "Notify_WorkOrder"; // NO I18N
            //moduleIdColoumn = NOTIFY_WORKORDER.WORKORDERID;
            moduleIdColoumn = "WORKORDERID"; // NO I18N
            //moduleNotificationId = NOTIFY_WORKORDER.NOTIFICATIONID;
            moduleNotificationId = "NOTIFICATIONID"; // NO I18N
        }

        else if (module.equalsIgnoreCase("Problem") || module.equalsIgnoreCase("Problems"))
        {
            //moduleTable = NOTIFY_PROBLEM.TABLE;
            moduleTable = "Notify_Problem"; // NO I18N
            //moduleIdColoumn = NOTIFY_PROBLEM.PROBLEMID;
            moduleIdColoumn = "PROBLEMID"; // NO I18N
            //moduleNotificationId = NOTIFY_PROBLEM.NOTIFICATIONID;
            moduleNotificationId = "NOTIFICATIONID"; // NO I18N
        }

        String coloumn1[] = {NOTIFICATION.NOTIFICATIONID};
        String coloumn2[] = {moduleNotificationId};
        String coloumn3[] = {NOTIFICATIONTODESC.NOTIFICATIONID};
        String coloumn4[] = {NOTIFICATION_RECIPIENTS.NOTIFICATIONID};
        String coloumn5[] = {NOTIFY_ATTACHMENTS.ATTACHMENTID};
        String coloumn6[] = {SDESKATTACHMENT.ATTACHMENTID};
        String coloumn7[] = {NOTIFY_ATTACHMENTS.NOTIFICATIONID};


        SelectQueryImpl selectQueryImpl = new SelectQueryImpl(new Table(NOTIFICATION.TABLE));
        selectQueryImpl.addSelectColumn(new Column(NOTIFICATION.TABLE, "*"));
        selectQueryImpl.addSelectColumn(new Column(NOTIFICATIONTODESC.TABLE, "*"));
        selectQueryImpl.addSelectColumn(new Column(NOTIFICATION_RECIPIENTS.TABLE, "*"));
        selectQueryImpl.addSelectColumn(new Column(SDESKATTACHMENT.TABLE,"*"));
        selectQueryImpl.addSelectColumn(new Column(NOTIFY_ATTACHMENTS.TABLE, "*"));

        selectQueryImpl.addJoin(new Join(NOTIFICATION.TABLE,moduleTable, coloumn1, coloumn2, Join.INNER_JOIN));
        selectQueryImpl.addJoin(new Join(NOTIFICATION.TABLE, NOTIFICATIONTODESC.TABLE, coloumn1, coloumn3, Join.INNER_JOIN));
        selectQueryImpl.addJoin(new Join(NOTIFICATION.TABLE, NOTIFICATION_RECIPIENTS.TABLE, coloumn1, coloumn4, Join.INNER_JOIN));
        selectQueryImpl.addJoin(new Join(NOTIFICATION.TABLE, NOTIFY_ATTACHMENTS.TABLE, coloumn1, coloumn7, Join.LEFT_JOIN));
        selectQueryImpl.addJoin(new Join(NOTIFY_ATTACHMENTS.TABLE, SDESKATTACHMENT.TABLE, coloumn5, coloumn6, Join.LEFT_JOIN));

        selectQueryImpl.setCriteria(new Criteria(new Column(NOTIFICATION.TABLE, NOTIFICATION.NOTIFICATIONID), notificationId, QueryConstants.EQUAL));
        DataObject notificationDataObject = null;
        try
        {
            notificationDataObject = DataAccessUtil.getInstance().get(selectQueryImpl);
        }
        catch (Exception e)
        {
            logger.log(Level.WARNING, "Execption while executing get(query) for single notification");
            e.printStackTrace();
            throw e;
        }
        return notificationDataObject;
    }

    /**
     * This method returns a conversation specific to a module as a DataObject.
     * NOTE: startIndex and count are not considered for request module, instead all notifications are returned.
     * @param module
     * @param moduleId
     * @param startIndex
     * @param count
     * @param needSystemNotification
     * @return DataObject
     * @throws Exception
     */
    public DataObject getGivenRangeOfConversationDO(String module, Long moduleId, Long startIndex, Long count, boolean needSystemNotification, boolean isAscending) throws Exception
    {
        if (startIndex == null)
        {
            getDefaultSetOfConversationDO(module, moduleId, needSystemNotification, isAscending);
        }

        String moduleTable = null;
        String moduleIdColoumn = null;
        String moduleNotificationId = null;

        if (module.equalsIgnoreCase("Change") || module.equalsIgnoreCase("Changes"))
        {
            //moduleTable = NOTIFY_CHANGE.TABLE;
            moduleTable = "Notify_Change"; // NO I18N
            // moduleIdColoumn = NOTIFY_CHANGE.CHANGEID;
            moduleIdColoumn = "CHANGEID"; // NO I18N
            //moduleNotificationId = NOTIFY_CHANGE.NOTIFICATIONID;
            moduleNotificationId = "NOTIFICATIONID"; // NO I18N
        }
        if (module.equalsIgnoreCase("Request") || module.equalsIgnoreCase("Requests"))
        {
            //moduleTable = NOTIFY_WORKORDER.TABLE;
            moduleTable = "Notify_WorkOrder"; // NO I18N
            //moduleIdColoumn = NOTIFY_WORKORDER.WORKORDERID;
            moduleIdColoumn = "WORKORDERID"; // NO I18N
            //moduleNotificationId = NOTIFY_WORKORDER.NOTIFICATIONID;
            moduleNotificationId = "NOTIFICATIONID"; // NO I18N
        }

        else if (module.equalsIgnoreCase("Problem") || module.equalsIgnoreCase("Problems"))
        {
            //moduleTable = NOTIFY_PROBLEM.TABLE;
            moduleTable = "Notify_Problem"; // NO I18N
            //moduleIdColoumn = NOTIFY_PROBLEM.PROBLEMID;
            moduleIdColoumn = "PROBLEMID"; // NO I18N
            //moduleNotificationId = NOTIFY_PROBLEM.NOTIFICATIONID;
            moduleNotificationId = "NOTIFICATIONID"; // NO I18N
        }

        String coloumn1[] = {NOTIFICATION.NOTIFICATIONID};
        String coloumn2[] = {moduleNotificationId};

        SelectQueryImpl selectQueryImpl = new SelectQueryImpl(new Table(NOTIFICATION.TABLE));
        selectQueryImpl.addSelectColumn(new Column(NOTIFICATION.TABLE, NOTIFICATION.NOTIFICATIONID));
        selectQueryImpl.addSelectColumn(new Column(NOTIFICATION.TABLE, NOTIFICATION.NOTIFICATIONDATE));
        selectQueryImpl.addSelectColumn(new Column(NOTIFICATION.TABLE, NOTIFICATION.SENDERID));
        selectQueryImpl.addSelectColumn(new Column(NOTIFICATION.TABLE, NOTIFICATION.NOTIFICATIONTYPE));
        selectQueryImpl.addSelectColumn(new Column(NOTIFICATION.TABLE, NOTIFICATION.HASATTACHMENT));
        selectQueryImpl.addJoin(new Join(NOTIFICATION.TABLE,moduleTable, coloumn1, coloumn2, Join.INNER_JOIN));
        Criteria criteria = new Criteria( new Column(moduleTable, moduleIdColoumn), moduleId, QueryConstants.EQUAL);
        if ( !needSystemNotification)
        {
            criteria = criteria.and(new Criteria(new Column(NOTIFICATION.TABLE, NOTIFICATION.SENDERID),"1", QueryConstants.NOT_EQUAL));
        }
        selectQueryImpl.addSortColumn(new SortColumn(NOTIFICATION.TABLE, NOTIFICATION.NOTIFICATIONDATE, isAscending));
        if(startIndex >= 0)
        {
            selectQueryImpl.setRange(new Range(startIndex.intValue(), count.intValue()));
        }

        DataObject conversationDataObject =null;
        selectQueryImpl.setCriteria(criteria);
        try
        {
            conversationDataObject = DataAccessUtil.getInstance().get(selectQueryImpl);
        }
        catch (Exception e)
        {
            logger.log(Level.WARNING, "Execption while executing get(query) for notifications");
            e.printStackTrace();
            throw e;
        }

        return conversationDataObject;
    }

    /**
     * This method links a notification to the given module(Change/Problem/Request)
     * @param notificationId
     * @param module
     * @param moduleId
     * @return
     * @throws Exception
     */
    private void linkNotificationToModule(Long notificationId, String module, Long moduleId) throws Exception
    {
        String moduleTable = null;
        String notifyModuleTable = null;
        String moduleIdColoumn = null;
        String moduleNotificationId = null;
        if (module.equalsIgnoreCase("Change") || module.equalsIgnoreCase("changes"))
        {
            moduleTable = "ChangeDetails"; // NO I18N
            notifyModuleTable = "Notify_Change"; // NO I18N
            moduleIdColoumn = "CHANGEID"; // NO I18N
            moduleNotificationId = "NOTIFICATIONID"; // NO I18N
        }
        //TODO: To refer Request team to use this method..
        if (module.equalsIgnoreCase("request") || module.equalsIgnoreCase("requests"))
        {
            moduleTable = "workorder"; // NO I18N
            notifyModuleTable = "Notify_WorkOrder"; // NO I18N
            moduleIdColoumn = "WORKORDERID"; // NO I18N
            moduleNotificationId = "NOTIFICATIONID"; // NO I18N
        }

        else if (module.equalsIgnoreCase("problem") || module.equalsIgnoreCase("problems"))
        {
            moduleTable = "Problem"; // NO I18N
            notifyModuleTable = "Notify_Problem"; // NO I18N
            moduleIdColoumn = "PROBLEMID"; // NO I18N
            moduleNotificationId = "NOTIFICATIONID"; // NO I18N
        }

        try
        {
            DataObject notifyDO = ResourcesUtil.getInstance().constructDataObject();
            Row notifyModuleRow = new Row(notifyModuleTable);
            notifyModuleRow.set(moduleIdColoumn, moduleId);
            notifyModuleRow.set("NOTIFICATIONID", notificationId); //NO I18N
            notifyDO.addRow(notifyModuleRow);
            ResourcesUtil.getInstance().add(notifyDO);
            logger.log(Level.INFO, "Notification with Id : " + notificationId+ " has been mapped to " + module + " with "+ module+"Id :" + moduleId);
        }
        catch (RemoteException e)
        {
            logger.log(Level.SEVERE, "Could not link notification with Id: " + notificationId + "to " + module + " with "+ module+"Id :" + moduleId);
            e.printStackTrace();
            throw e;
        }
        catch (DataAccessException e)
        {
            logger.log(Level.SEVERE, "Could not link notification with Id: " + notificationId + "to " + module + " with "+ module+"Id :" + moduleId);
            e.printStackTrace();
            throw e;
        }
        catch (Exception e)
        {
            logger.log(Level.SEVERE, "Could not link notification with Id: " + notificationId + "to " + module + " with "+ module+"Id :" + moduleId);
            logger.log(Level.SEVERE, "Could not get PersistenceRemote");
            e.printStackTrace();
            throw e;
        }

    }

    /***
     * To persist Reply Forward mails
     * Transforms NotificationJSON in required format and inserted into the Database.
     * @param inputJsonObject
     * @return
     * @throws Exception
     */
    public Long persistNotificationJSON(JSONObject inputJsonObject, String module, Long moduleId) throws Exception
    {
        Long notificationId = null;
        String messageId = null;
        ResourcesUtil rUtil = null;
        HashMap<String, Integer> fileSizeMap = new HashMap<String, Integer>();
        try
        {
            JSONObject jsonObject = inputJsonObject.getJSONObject("notification");
            JSONArray toArray = jsonObject.getJSONArray("to");
            JSONArray attachments = null;
            String attachmentNames = null;
            String attachmentSize = null;
            String[] attachmentPathArray = null;
            ArrayList<String> attachmentNameArrayList = null; // New Attachments
            ArrayList<Long> forwardedAttachmentIdList = null;// Forwarded Attachments
            String ccAddress = "";
            Long fromUserID = null;
            try
            {
                fromUserID = inputJsonObject.getLong("fromID"); // to be used only in nonlogin case;
            }
            catch (JSONException jsonException)
            {
                fromUserID = ServiceDeskUtil.getInstance().getUserId();
                logger.log(Level.INFO,"formID not available.");
            }

            if(jsonObject.has("cc"))
            {
                JSONArray ccArray = jsonObject.getJSONArray("cc");
                ccAddress = SDPAPIJSONUtil.getInstance().jsonArrayToString(ccArray);
            }
            String toAddress = SDPAPIJSONUtil.getInstance().jsonArrayToString(toArray);
            if(jsonObject.has("attachments"))
            {
                forwardedAttachmentIdList = new ArrayList<Long>();
                ArrayList<JSONObject> forwardedAttachmentList = new ArrayList<JSONObject>();
                attachmentNameArrayList = new ArrayList<String>();
                attachments = jsonObject.getJSONArray("attachments");
                for(int i = 0; i < attachments.length(); i++)
                {
                    JSONObject attachment = (JSONObject)attachments.get(i);
                    if(attachment.has("id"))
                    {
                        forwardedAttachmentIdList.add(attachment.getLong("id"));
                        forwardedAttachmentList.add(attachment);

                    }
                    else
                    {
                        String name=URLDecoder.decode(attachment.getString("name"),ServiceDeskUtil.ENCODING_FORMAT);
                        attachmentNameArrayList.add(name.replace(",", "_"));
                    }
                }
                String baseAddress = ServiceDeskUtil.getInstance().getAttachmentPath();
                List<HashMap> forwardedAttachmentDetails = AttachmentUtil.getInstance().getAttachmentDetailsForId(forwardedAttachmentIdList);
                for(JSONObject attachment :forwardedAttachmentList)
                {
                    for(HashMap forwardedAttachment :forwardedAttachmentDetails)
                    {
                        if(((String) forwardedAttachment.get("id")).equalsIgnoreCase(attachment.getString("id"))  && ((String) forwardedAttachment.get("key")).equalsIgnoreCase(attachment.getString("key")))
                        {
                            BufferedInputStream attchBufferedInputStream = null;
                            try
                            {
                                String filePath = (String) forwardedAttachment.get("path");
                                //filePath=baseAddress+filePath;
                                filePath=filePath.replaceFirst("\\..", Matcher.quoteReplacement(baseAddress));
                                File file = new File(filePath);
                                InputStream fileInputStream =  new FileInputStream(file);
                                attchBufferedInputStream = new BufferedInputStream(fileInputStream);
                                String fileName = (String) forwardedAttachment.get("name");
                                AttachmentUtil.getInstance().storeAttachmentInTemp(fileName, fromUserID, attchBufferedInputStream, "Notifications"); // NO I18N
                                attchBufferedInputStream.close();
                                attachmentNameArrayList.add((String) forwardedAttachment.get("name"));
                            }
                            finally
                            {
                                attchBufferedInputStream.close();
                            }
                            break;
                        }
                    }

                }

                attachmentPathArray = attachmentNameArrayList.toArray(new String[0]);

                for(int i = 0; i < attachmentPathArray.length ; i++)
                {
                    attachmentPathArray[i] = ResourcesUtil.getUserDir() + File.separator +"Attachments" + File.separator + "Notifications" + File.separator + fromUserID.toString() + File.separator + attachmentPathArray[i]; // NO I18N
                    File file = new File(attachmentPathArray[i]);
                    if(file.exists())
                    {

							if(attachmentNames==null)//(i ==0)
                        {
                            attachmentSize = "" + file.length();
                            attachmentNames = "" + attachmentNameArrayList.get(i);
                        }
                        else
                        {
                            attachmentSize += "," + file.length();
                            attachmentNames += "," + attachmentNameArrayList.get(i);
                        }
                        fileSizeMap.put(attachmentNameArrayList.get(i), (int) file.length());
                    }
                    else
                    {
                        logger.log(Level.WARNING, "Wrong attachmentName :: "+ attachmentPathArray[i] );
                    }
                }

				}
				//To show error on uploading restricted files in change send notification
                if(attachmentNameArrayList.size() != fileSizeMap.size())
                {
                    ServiceDeskException sde = new ServiceDeskException("Upload failed");//No I18N
                    sde.setErrorCode(ServiceDeskErrorCode.UPLOAD_FAILED);
                    throw sde;
				}
            String desc= URLDecoder.decode(jsonObject.getString("description"),ServiceDeskUtil.ENCODING_FORMAT) ;
            String subject = URLDecoder.decode(jsonObject.getString("title"),ServiceDeskUtil.ENCODING_FORMAT) ;

            String notificationType = jsonObject.getString("type");
            if(notificationType.equalsIgnoreCase("change_forward"))
            {
                notificationType = "CHG_FORWARD"; // NO I18N
            }
            else if(notificationType.equalsIgnoreCase("change_reply"))
            {
                notificationType = "CHG_REPLY"; // NO I18N
            }


            try
            {
                //messageId = sendMailNotification(toAddress, subject, desc, ccAddress, null, attachmentNameArray);
                messageId = sendMailNotification(null, toAddress, subject, desc, ccAddress, "text/html", attachmentPathArray, null, null, null, null, module, moduleId, false);// NO I18N
            }
            catch (ServiceDeskException e)
            {
                if(!fileSizeMap.isEmpty())
                {
                    for(String fileName : fileSizeMap.keySet())
                    {
                        AttachmentUtil.getInstance().deleteFromTemp(fileName, "Notifications", fromUserID); // NO I18N
                    }
                }
                logger.log(Level.FINE,"Could not send mail.");
                throw e;
            }
            try
            {
                notificationId = populateNotificationWithModule(fromUserID, getSubjectWithModuleDelim(subject, module, moduleId), desc, notificationType, messageId, toAddress, ccAddress, attachmentNames, attachmentSize, module, moduleId);
            }
            catch(Exception e)
            {
                if(!fileSizeMap.isEmpty())
                {
                    for(String fileName : fileSizeMap.keySet())
                    {
                        AttachmentUtil.getInstance().deleteFromTemp(fileName, "Notifications", fromUserID); // NO I18N
                    }
                }
                e.printStackTrace();
                logger.log(Level.SEVERE, "Could not populate notificationWithModule.");
                throw e;
            }
        }
        catch (JSONException e)
        {
            //not correct format
            logger.log(Level.SEVERE, "Could not parse JSON, as input JSON doesn't comply with SDP API Specification: -->" + inputJsonObject.keys().toString());
            e.printStackTrace();
            throw e;

        }


        return notificationId;

    }

    public Long populateNotificationWithModule(Long fromId, String subject, String content, String notificationType, String messageID, String toAddress, String ccAddress, String attachmentNames, String attachmentSize, String module, Long moduleId) throws Exception
    {
        Long notificationID = null;
        boolean started = false;
        ResourcesUtil rUtil = null;
        try
        {
            rUtil = ResourcesUtil.getInstance();

            logger.log(Level.INFO, "transaction status : " +rUtil.getUserTransaction().getStatus());
            boolean active = (rUtil.getUserTransaction().getStatus() == javax.transaction.Status.STATUS_ACTIVE);

            if (!active)
            {
                rUtil.getUserTransaction().begin();
                started = true;
                logger.log(Level.INFO, "New transaction begun");
            }
            notificationID = populateNotificationTable(null, fromId, subject, content, notificationType, messageID, toAddress, ccAddress, attachmentNames, attachmentSize, "Notifications", true); // NO I18N
            linkNotificationToModule(notificationID, module, moduleId);

            if(started)
            {
                logger.log(Level.INFO, "New transaction committed");
                rUtil.getUserTransaction().commit();
            }
        }
        catch (Exception e)
        {
            if(started)
            {
                logger.log(Level.INFO, "New transaction rolled back");
                ResourcesUtil.getInstance().getUserTransaction().rollback();
            }
            e.printStackTrace();
            throw e;
        }
        return notificationID;
    }

    public String getSubjectWithModuleDelim(String subject, String module, Long moduleId) throws Exception
    {
        String baseDelimiter = DelimiterUtil.getInstance().getModuleBasedDelimiter("BaseDelimiter"); // NO I18N
        if(module.equalsIgnoreCase("change") || module.equalsIgnoreCase("changes"))
        {
            module = "Change"; // NO I18N
        }
        else if(module.equalsIgnoreCase("request") || module.equalsIgnoreCase("requests"))
        {
            module = "Request"; // NO I18N
        }
        else if(module.equalsIgnoreCase("problem") || module.equalsIgnoreCase("problems"))
        {
            module = "Problem"; // NO I18N
        }

        String moduleDelimiter = DelimiterUtil.getInstance().getModuleBasedDelimiter(module);

        String baseDelimiterTemp;

        baseDelimiterTemp=baseDelimiter.replace("$", "\\$");
        baseDelimiterTemp=baseDelimiterTemp.replace("^", "\\^");

        String pattern = ".*" + baseDelimiterTemp + "\\s*"+ moduleDelimiter + "\\s*"+ "-" + "\\s*"+ moduleId + "\\s*"+  baseDelimiterTemp + ".*";
        if(!subject.matches(pattern) && moduleDelimiter!=null)
        {
            subject = baseDelimiter + moduleDelimiter + "-" + moduleId + baseDelimiter + subject;
        }
        return subject;
    }

}

